/*
 * Copyright 2019, Yahoo Inc.
 * Copyrights licensed under the New BSD License.
 * See the accompanying LICENSE file for terms.
 */

(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('prop-types'), require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'prop-types', 'react'], factory) :
  (global = global || self, factory(global.ReactIntl = {}, global.PropTypes, global.React));
}(this, function (exports, PropTypes, React) { 'use strict';

  if (typeof React === 'undefined') {
      throw new ReferenceError('React must be loaded before ReactIntl.');
  }


  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
  var React__default = 'default' in React ? React['default'] : React;

  function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    }
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  var bool = PropTypes.bool,
      number = PropTypes.number,
      string = PropTypes.string,
      func = PropTypes.func,
      object = PropTypes.object,
      oneOf = PropTypes.oneOf,
      shape = PropTypes.shape,
      any = PropTypes.any,
      oneOfType = PropTypes.oneOfType;
  var localeMatcher = oneOf(['best fit', 'lookup']);
  var narrowShortLong = oneOf(['narrow', 'short', 'long']);
  var numeric2digit = oneOf(['numeric', '2-digit']);
  var funcReq = func.isRequired;
  var intlConfigPropTypes = {
    locale: string,
    timeZone: string,
    formats: object,
    messages: object,
    textComponent: any,
    defaultLocale: string,
    defaultFormats: object,
    onError: func
  };
  var intlFormatPropTypes = {
    formatDate: funcReq,
    formatTime: funcReq,
    formatRelative: funcReq,
    formatNumber: funcReq,
    formatPlural: funcReq,
    formatMessage: funcReq,
    formatHTMLMessage: funcReq
  };
  var intlShape = shape(_objectSpread({}, intlConfigPropTypes, intlFormatPropTypes, {
    formatters: object,
    now: funcReq
  }));
  var messageDescriptorPropTypes = {
    id: string.isRequired,
    description: oneOfType([string, object]),
    defaultMessage: string
  };
  var dateTimeFormatPropTypes = {
    localeMatcher: localeMatcher,
    formatMatcher: oneOf(['basic', 'best fit']),
    timeZone: string,
    hour12: bool,
    weekday: narrowShortLong,
    era: narrowShortLong,
    year: numeric2digit,
    month: oneOf(['numeric', '2-digit', 'narrow', 'short', 'long']),
    day: numeric2digit,
    hour: numeric2digit,
    minute: numeric2digit,
    second: numeric2digit,
    timeZoneName: oneOf(['short', 'long'])
  };
  var numberFormatPropTypes = {
    localeMatcher: localeMatcher,
    style: oneOf(['decimal', 'currency', 'percent']),
    currency: string,
    currencyDisplay: oneOf(['symbol', 'code', 'name']),
    useGrouping: bool,
    minimumIntegerDigits: number,
    minimumFractionDigits: number,
    maximumFractionDigits: number,
    minimumSignificantDigits: number,
    maximumSignificantDigits: number
  };
  var relativeFormatPropTypes = {
    style: oneOf(['best fit', 'numeric']),
    units: oneOf(['second', 'minute', 'hour', 'day', 'month', 'year', 'second-short', 'minute-short', 'hour-short', 'day-short', 'month-short', 'year-short'])
  };
  var pluralFormatPropTypes = {
    type: oneOf(['cardinal', 'ordinal'])
  };

  /*
   * Copyright 2015, Yahoo Inc.
   * Copyrights licensed under the New BSD License.
   * See the accompanying LICENSE file for terms.
   */
  function defineMessages(messageDescriptors) {
    // This simply returns what's passed-in because it's meant to be a hook for
    // babel-plugin-react-intl.
    return messageDescriptors;
  }

  function unwrapExports (x) {
  	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var reactIs_production_min = createCommonjsModule(function (module, exports) {

  Object.defineProperty(exports, "__esModule", {
    value: !0
  });
  var b = "function" === typeof Symbol && Symbol.for,
      c = b ? Symbol.for("react.element") : 60103,
      d = b ? Symbol.for("react.portal") : 60106,
      e = b ? Symbol.for("react.fragment") : 60107,
      f = b ? Symbol.for("react.strict_mode") : 60108,
      g = b ? Symbol.for("react.profiler") : 60114,
      h = b ? Symbol.for("react.provider") : 60109,
      k = b ? Symbol.for("react.context") : 60110,
      l = b ? Symbol.for("react.async_mode") : 60111,
      m = b ? Symbol.for("react.concurrent_mode") : 60111,
      n = b ? Symbol.for("react.forward_ref") : 60112,
      p = b ? Symbol.for("react.suspense") : 60113,
      q = b ? Symbol.for("react.memo") : 60115,
      r = b ? Symbol.for("react.lazy") : 60116;

  function t(a) {
    if ("object" === typeof a && null !== a) {
      var u = a.$$typeof;

      switch (u) {
        case c:
          switch (a = a.type, a) {
            case l:
            case m:
            case e:
            case g:
            case f:
            case p:
              return a;

            default:
              switch (a = a && a.$$typeof, a) {
                case k:
                case n:
                case h:
                  return a;

                default:
                  return u;
              }

          }

        case r:
        case q:
        case d:
          return u;
      }
    }
  }

  function v(a) {
    return t(a) === m;
  }

  exports.typeOf = t;
  exports.AsyncMode = l;
  exports.ConcurrentMode = m;
  exports.ContextConsumer = k;
  exports.ContextProvider = h;
  exports.Element = c;
  exports.ForwardRef = n;
  exports.Fragment = e;
  exports.Lazy = r;
  exports.Memo = q;
  exports.Portal = d;
  exports.Profiler = g;
  exports.StrictMode = f;
  exports.Suspense = p;

  exports.isValidElementType = function (a) {
    return "string" === typeof a || "function" === typeof a || a === e || a === m || a === g || a === f || a === p || "object" === typeof a && null !== a && (a.$$typeof === r || a.$$typeof === q || a.$$typeof === h || a.$$typeof === k || a.$$typeof === n);
  };

  exports.isAsyncMode = function (a) {
    return v(a) || t(a) === l;
  };

  exports.isConcurrentMode = v;

  exports.isContextConsumer = function (a) {
    return t(a) === k;
  };

  exports.isContextProvider = function (a) {
    return t(a) === h;
  };

  exports.isElement = function (a) {
    return "object" === typeof a && null !== a && a.$$typeof === c;
  };

  exports.isForwardRef = function (a) {
    return t(a) === n;
  };

  exports.isFragment = function (a) {
    return t(a) === e;
  };

  exports.isLazy = function (a) {
    return t(a) === r;
  };

  exports.isMemo = function (a) {
    return t(a) === q;
  };

  exports.isPortal = function (a) {
    return t(a) === d;
  };

  exports.isProfiler = function (a) {
    return t(a) === g;
  };

  exports.isStrictMode = function (a) {
    return t(a) === f;
  };

  exports.isSuspense = function (a) {
    return t(a) === p;
  };
  });

  unwrapExports(reactIs_production_min);
  var reactIs_production_min_1 = reactIs_production_min.typeOf;
  var reactIs_production_min_2 = reactIs_production_min.AsyncMode;
  var reactIs_production_min_3 = reactIs_production_min.ConcurrentMode;
  var reactIs_production_min_4 = reactIs_production_min.ContextConsumer;
  var reactIs_production_min_5 = reactIs_production_min.ContextProvider;
  var reactIs_production_min_6 = reactIs_production_min.Element;
  var reactIs_production_min_7 = reactIs_production_min.ForwardRef;
  var reactIs_production_min_8 = reactIs_production_min.Fragment;
  var reactIs_production_min_9 = reactIs_production_min.Lazy;
  var reactIs_production_min_10 = reactIs_production_min.Memo;
  var reactIs_production_min_11 = reactIs_production_min.Portal;
  var reactIs_production_min_12 = reactIs_production_min.Profiler;
  var reactIs_production_min_13 = reactIs_production_min.StrictMode;
  var reactIs_production_min_14 = reactIs_production_min.Suspense;
  var reactIs_production_min_15 = reactIs_production_min.isValidElementType;
  var reactIs_production_min_16 = reactIs_production_min.isAsyncMode;
  var reactIs_production_min_17 = reactIs_production_min.isConcurrentMode;
  var reactIs_production_min_18 = reactIs_production_min.isContextConsumer;
  var reactIs_production_min_19 = reactIs_production_min.isContextProvider;
  var reactIs_production_min_20 = reactIs_production_min.isElement;
  var reactIs_production_min_21 = reactIs_production_min.isForwardRef;
  var reactIs_production_min_22 = reactIs_production_min.isFragment;
  var reactIs_production_min_23 = reactIs_production_min.isLazy;
  var reactIs_production_min_24 = reactIs_production_min.isMemo;
  var reactIs_production_min_25 = reactIs_production_min.isPortal;
  var reactIs_production_min_26 = reactIs_production_min.isProfiler;
  var reactIs_production_min_27 = reactIs_production_min.isStrictMode;
  var reactIs_production_min_28 = reactIs_production_min.isSuspense;

  var reactIs_development = createCommonjsModule(function (module, exports) {

  {
    (function () {

      Object.defineProperty(exports, '__esModule', {
        value: true
      }); // The Symbol used to tag the ReactElement-like types. If there is no native Symbol
      // nor polyfill, then a plain number is used for performance.

      var hasSymbol = typeof Symbol === 'function' && Symbol.for;
      var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
      var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
      var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
      var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
      var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
      var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
      var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace;
      var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
      var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
      var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
      var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
      var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
      var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;

      function isValidElementType(type) {
        return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
        type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE);
      }
      /**
       * Forked from fbjs/warning:
       * https://github.com/facebook/fbjs/blob/e66ba20ad5be433eb54423f2b097d829324d9de6/packages/fbjs/src/__forks__/warning.js
       *
       * Only change is we use console.warn instead of console.error,
       * and do nothing when 'console' is not supported.
       * This really simplifies the code.
       * ---
       * Similar to invariant but only logs a warning if the condition is not met.
       * This can be used to log issues in development environments in critical
       * paths. Removing the logging code for production environments will keep the
       * same logic and follow the same code paths.
       */


      var lowPriorityWarning = function () {};

      {
        var printWarning = function (format) {
          for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            args[_key - 1] = arguments[_key];
          }

          var argIndex = 0;
          var message = 'Warning: ' + format.replace(/%s/g, function () {
            return args[argIndex++];
          });

          if (typeof console !== 'undefined') {
            console.warn(message);
          }

          try {
            // --- Welcome to debugging React ---
            // This error was thrown as a convenience so that you can use this stack
            // to find the callsite that caused this warning to fire.
            throw new Error(message);
          } catch (x) {}
        };

        lowPriorityWarning = function (condition, format) {
          if (format === undefined) {
            throw new Error('`lowPriorityWarning(condition, format, ...args)` requires a warning ' + 'message argument');
          }

          if (!condition) {
            for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
              args[_key2 - 2] = arguments[_key2];
            }

            printWarning.apply(undefined, [format].concat(args));
          }
        };
      }
      var lowPriorityWarning$1 = lowPriorityWarning;

      function typeOf(object) {
        if (typeof object === 'object' && object !== null) {
          var $$typeof = object.$$typeof;

          switch ($$typeof) {
            case REACT_ELEMENT_TYPE:
              var type = object.type;

              switch (type) {
                case REACT_ASYNC_MODE_TYPE:
                case REACT_CONCURRENT_MODE_TYPE:
                case REACT_FRAGMENT_TYPE:
                case REACT_PROFILER_TYPE:
                case REACT_STRICT_MODE_TYPE:
                case REACT_SUSPENSE_TYPE:
                  return type;

                default:
                  var $$typeofType = type && type.$$typeof;

                  switch ($$typeofType) {
                    case REACT_CONTEXT_TYPE:
                    case REACT_FORWARD_REF_TYPE:
                    case REACT_PROVIDER_TYPE:
                      return $$typeofType;

                    default:
                      return $$typeof;
                  }

              }

            case REACT_LAZY_TYPE:
            case REACT_MEMO_TYPE:
            case REACT_PORTAL_TYPE:
              return $$typeof;
          }
        }

        return undefined;
      } // AsyncMode is deprecated along with isAsyncMode


      var AsyncMode = REACT_ASYNC_MODE_TYPE;
      var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
      var ContextConsumer = REACT_CONTEXT_TYPE;
      var ContextProvider = REACT_PROVIDER_TYPE;
      var Element = REACT_ELEMENT_TYPE;
      var ForwardRef = REACT_FORWARD_REF_TYPE;
      var Fragment = REACT_FRAGMENT_TYPE;
      var Lazy = REACT_LAZY_TYPE;
      var Memo = REACT_MEMO_TYPE;
      var Portal = REACT_PORTAL_TYPE;
      var Profiler = REACT_PROFILER_TYPE;
      var StrictMode = REACT_STRICT_MODE_TYPE;
      var Suspense = REACT_SUSPENSE_TYPE;
      var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

      function isAsyncMode(object) {
        {
          if (!hasWarnedAboutDeprecatedIsAsyncMode) {
            hasWarnedAboutDeprecatedIsAsyncMode = true;
            lowPriorityWarning$1(false, 'The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
          }
        }
        return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
      }

      function isConcurrentMode(object) {
        return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
      }

      function isContextConsumer(object) {
        return typeOf(object) === REACT_CONTEXT_TYPE;
      }

      function isContextProvider(object) {
        return typeOf(object) === REACT_PROVIDER_TYPE;
      }

      function isElement(object) {
        return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
      }

      function isForwardRef(object) {
        return typeOf(object) === REACT_FORWARD_REF_TYPE;
      }

      function isFragment(object) {
        return typeOf(object) === REACT_FRAGMENT_TYPE;
      }

      function isLazy(object) {
        return typeOf(object) === REACT_LAZY_TYPE;
      }

      function isMemo(object) {
        return typeOf(object) === REACT_MEMO_TYPE;
      }

      function isPortal(object) {
        return typeOf(object) === REACT_PORTAL_TYPE;
      }

      function isProfiler(object) {
        return typeOf(object) === REACT_PROFILER_TYPE;
      }

      function isStrictMode(object) {
        return typeOf(object) === REACT_STRICT_MODE_TYPE;
      }

      function isSuspense(object) {
        return typeOf(object) === REACT_SUSPENSE_TYPE;
      }

      exports.typeOf = typeOf;
      exports.AsyncMode = AsyncMode;
      exports.ConcurrentMode = ConcurrentMode;
      exports.ContextConsumer = ContextConsumer;
      exports.ContextProvider = ContextProvider;
      exports.Element = Element;
      exports.ForwardRef = ForwardRef;
      exports.Fragment = Fragment;
      exports.Lazy = Lazy;
      exports.Memo = Memo;
      exports.Portal = Portal;
      exports.Profiler = Profiler;
      exports.StrictMode = StrictMode;
      exports.Suspense = Suspense;
      exports.isValidElementType = isValidElementType;
      exports.isAsyncMode = isAsyncMode;
      exports.isConcurrentMode = isConcurrentMode;
      exports.isContextConsumer = isContextConsumer;
      exports.isContextProvider = isContextProvider;
      exports.isElement = isElement;
      exports.isForwardRef = isForwardRef;
      exports.isFragment = isFragment;
      exports.isLazy = isLazy;
      exports.isMemo = isMemo;
      exports.isPortal = isPortal;
      exports.isProfiler = isProfiler;
      exports.isStrictMode = isStrictMode;
      exports.isSuspense = isSuspense;
    })();
  }
  });

  unwrapExports(reactIs_development);
  var reactIs_development_1 = reactIs_development.typeOf;
  var reactIs_development_2 = reactIs_development.AsyncMode;
  var reactIs_development_3 = reactIs_development.ConcurrentMode;
  var reactIs_development_4 = reactIs_development.ContextConsumer;
  var reactIs_development_5 = reactIs_development.ContextProvider;
  var reactIs_development_6 = reactIs_development.Element;
  var reactIs_development_7 = reactIs_development.ForwardRef;
  var reactIs_development_8 = reactIs_development.Fragment;
  var reactIs_development_9 = reactIs_development.Lazy;
  var reactIs_development_10 = reactIs_development.Memo;
  var reactIs_development_11 = reactIs_development.Portal;
  var reactIs_development_12 = reactIs_development.Profiler;
  var reactIs_development_13 = reactIs_development.StrictMode;
  var reactIs_development_14 = reactIs_development.Suspense;
  var reactIs_development_15 = reactIs_development.isValidElementType;
  var reactIs_development_16 = reactIs_development.isAsyncMode;
  var reactIs_development_17 = reactIs_development.isConcurrentMode;
  var reactIs_development_18 = reactIs_development.isContextConsumer;
  var reactIs_development_19 = reactIs_development.isContextProvider;
  var reactIs_development_20 = reactIs_development.isElement;
  var reactIs_development_21 = reactIs_development.isForwardRef;
  var reactIs_development_22 = reactIs_development.isFragment;
  var reactIs_development_23 = reactIs_development.isLazy;
  var reactIs_development_24 = reactIs_development.isMemo;
  var reactIs_development_25 = reactIs_development.isPortal;
  var reactIs_development_26 = reactIs_development.isProfiler;
  var reactIs_development_27 = reactIs_development.isStrictMode;
  var reactIs_development_28 = reactIs_development.isSuspense;

  var reactIs = createCommonjsModule(function (module) {

  {
    module.exports = reactIs_development;
  }
  });
  var reactIs_1 = reactIs.isValidElementType;

  /**
   * Copyright 2015, Yahoo! Inc.
   * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
   */



  var REACT_STATICS = {
    childContextTypes: true,
    contextType: true,
    contextTypes: true,
    defaultProps: true,
    displayName: true,
    getDefaultProps: true,
    getDerivedStateFromError: true,
    getDerivedStateFromProps: true,
    mixins: true,
    propTypes: true,
    type: true
  };
  var KNOWN_STATICS = {
    name: true,
    length: true,
    prototype: true,
    caller: true,
    callee: true,
    arguments: true,
    arity: true
  };
  var FORWARD_REF_STATICS = {
    '$$typeof': true,
    render: true,
    defaultProps: true,
    displayName: true,
    propTypes: true
  };
  var MEMO_STATICS = {
    '$$typeof': true,
    compare: true,
    defaultProps: true,
    displayName: true,
    propTypes: true,
    type: true
  };
  var TYPE_STATICS = {};
  TYPE_STATICS[reactIs.ForwardRef] = FORWARD_REF_STATICS;

  function getStatics(component) {
    if (reactIs.isMemo(component)) {
      return MEMO_STATICS;
    }

    return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
  }

  var defineProperty = Object.defineProperty;
  var getOwnPropertyNames = Object.getOwnPropertyNames;
  var getOwnPropertySymbols = Object.getOwnPropertySymbols;
  var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
  var getPrototypeOf = Object.getPrototypeOf;
  var objectPrototype = Object.prototype;

  function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
    if (typeof sourceComponent !== 'string') {
      // don't hoist over string (html) components
      if (objectPrototype) {
        var inheritedComponent = getPrototypeOf(sourceComponent);

        if (inheritedComponent && inheritedComponent !== objectPrototype) {
          hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
        }
      }

      var keys = getOwnPropertyNames(sourceComponent);

      if (getOwnPropertySymbols) {
        keys = keys.concat(getOwnPropertySymbols(sourceComponent));
      }

      var targetStatics = getStatics(targetComponent);
      var sourceStatics = getStatics(sourceComponent);

      for (var i = 0; i < keys.length; ++i) {
        var key = keys[i];

        if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
          var descriptor = getOwnPropertyDescriptor(sourceComponent, key);

          try {
            // Avoid failures from read-only properties
            defineProperty(targetComponent, key, descriptor);
          } catch (e) {}
        }
      }

      return targetComponent;
    }

    return targetComponent;
  }

  var hoistNonReactStatics_cjs = hoistNonReactStatics;

  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var invariant = function (condition, format, a, b, c, d, e, f) {
    {
      if (format === undefined) {
        throw new Error('invariant requires an error message argument');
      }
    }

    if (!condition) {
      var error;

      if (format === undefined) {
        error = new Error('Minified exception occurred; use the non-minified dev environment ' + 'for the full error message and additional helpful warnings.');
      } else {
        var args = [a, b, c, d, e, f];
        var argIndex = 0;
        error = new Error(format.replace(/%s/g, function () {
          return args[argIndex++];
        }));
        error.name = 'Invariant Violation';
      }

      error.framesToPop = 1; // we don't care about invariant's own frame

      throw error;
    }
  };

  var invariant_1 = invariant;

  var ESCAPED_CHARS = {
    38: '&amp;',
    62: '&gt;',
    60: '&lt;',
    34: '&quot;',
    39: '&#x27;'
  };
  var UNSAFE_CHARS_REGEX = /[&><"']/g;
  function escape(str) {
    return ('' + str).replace(UNSAFE_CHARS_REGEX, function (match) {
      return ESCAPED_CHARS[match.charCodeAt()];
    });
  }
  function filterProps(props, whitelist) {
    var defaults = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    return whitelist.reduce(function (filtered, name) {
      if (props.hasOwnProperty(name)) {
        filtered[name] = props[name];
      } else if (defaults.hasOwnProperty(name)) {
        filtered[name] = defaults[name];
      }

      return filtered;
    }, {});
  }
  function invariantIntlContext() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        intl = _ref.intl;

    invariant_1(intl, '[React Intl] Could not find required `intl` object. ' + '<IntlProvider> needs to exist in the component ancestry.');
  }
  function shallowEquals(objA, objB) {
    if (objA === objB) {
      return true;
    }

    if (_typeof(objA) !== 'object' || objA === null || _typeof(objB) !== 'object' || objB === null) {
      return false;
    }

    var keysA = Object.keys(objA);
    var keysB = Object.keys(objB);

    if (keysA.length !== keysB.length) {
      return false;
    } // Test for A's keys different from B.


    var bHasOwnProperty = Object.prototype.hasOwnProperty.bind(objB);

    for (var i = 0; i < keysA.length; i++) {
      if (!bHasOwnProperty(keysA[i]) || objA[keysA[i]] !== objB[keysA[i]]) {
        return false;
      }
    }

    return true;
  }
  function shouldIntlComponentUpdate(_ref2, nextProps, nextState) {
    var props = _ref2.props,
        state = _ref2.state;
    return !shallowEquals(nextProps, props) || !shallowEquals(nextState, state);
  }
  function createError(message, exception) {
    var eMsg = exception ? "\n".concat(exception) : '';
    return "[React Intl] ".concat(message).concat(eMsg);
  }
  function defaultErrorHandler(error) {
    {
      console.error(error);
    }
  }

  function getDisplayName(Component) {
    return Component.displayName || Component.name || 'Component';
  }

  var IntlContext = React.createContext(null);
  var IntlConsumer = IntlContext.Consumer,
      IntlProvider = IntlContext.Provider;
  var Provider = IntlProvider;
  var Context = IntlContext;
  function withIntl(componentOrOptions, options) {
    if (reactIs_1(componentOrOptions)) {
      // use call to make `options` available on `this`
      return createWrapper.call({
        options: options
      }, componentOrOptions);
    } // return a function with `options` bound to `this`


    return createWrapper.bind({
      options: componentOrOptions
    });
  }

  function createWrapper(WrappedComponent) {
    var options = this && this.options || {};
    var _options$intlPropName = options.intlPropName,
        intlPropName = _options$intlPropName === void 0 ? 'intl' : _options$intlPropName,
        _options$forwardRef = options.forwardRef,
        forwardRef = _options$forwardRef === void 0 ? false : _options$forwardRef,
        _options$withRef = options.withRef,
        withRef = _options$withRef === void 0 ? false : _options$withRef,
        _options$enforceConte = options.enforceContext,
        enforceContext = _options$enforceConte === void 0 ? true : _options$enforceConte;
    invariant_1(!withRef, '[React Intl] withRef and getWrappedInstance() are deprecated, ' + "instead use the 'forwardRef' option and create a ref directly on the wrapped component.");

    var WithIntl =
    /*#__PURE__*/
    function (_Component) {
      _inherits(WithIntl, _Component);

      function WithIntl() {
        _classCallCheck(this, WithIntl);

        return _possibleConstructorReturn(this, _getPrototypeOf(WithIntl).apply(this, arguments));
      }

      _createClass(WithIntl, [{
        key: "render",
        value: function render() {
          var _this = this;

          return React__default.createElement(IntlConsumer, null, function (intl) {
            if (enforceContext) {
              invariantIntlContext({
                intl: intl
              });
            }

            return React__default.createElement(WrappedComponent, _extends({}, _objectSpread({}, _this.props, _defineProperty({}, intlPropName, intl)), {
              ref: forwardRef ? _this.props.forwardedRef : null
            }));
          });
        }
      }]);

      return WithIntl;
    }(React.Component);

    _defineProperty(WithIntl, "displayName", "withIntl(".concat(getDisplayName(WrappedComponent), ")"));

    _defineProperty(WithIntl, "WrappedComponent", WrappedComponent);

    if (forwardRef) {
      return hoistNonReactStatics_cjs(React__default.forwardRef(function (props, ref) {
        return React__default.createElement(WithIntl, _extends({}, props, {
          forwardedRef: ref
        }));
      }), WrappedComponent);
    }

    return hoistNonReactStatics_cjs(WithIntl, WrappedComponent);
  }

  function useIntl() {
    var intl = React.useContext(Context);
    invariantIntlContext({
      intl: intl
    });
    return intl;
  }

  /*
  Copyright (c) 2014, Yahoo! Inc. All rights reserved.
  Copyrights licensed under the New BSD License.
  See the accompanying LICENSE file for terms.
  */
  var __extends = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || {
        __proto__: []
      } instanceof Array && function (d, b) {
        d.__proto__ = b;
      } || function (d, b) {
        for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
      };

      return extendStatics(d, b);
    };

    return function (d, b) {
      extendStatics(d, b);

      function __() {
        this.constructor = d;
      }

      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  }();

  var Compiler =
  /** @class */
  function () {
    function Compiler(locales, formats) {
      this.locales = [];
      this.formats = {
        number: {},
        date: {},
        time: {}
      };
      this.pluralNumberFormat = null;
      this.currentPlural = null;
      this.pluralStack = [];
      this.locales = locales;
      this.formats = formats;
    }

    Compiler.prototype.compile = function (ast) {
      this.pluralStack = [];
      this.currentPlural = null;
      this.pluralNumberFormat = null;
      return this.compileMessage(ast);
    };

    Compiler.prototype.compileMessage = function (ast) {
      var _this = this;

      if (!(ast && ast.type === 'messageFormatPattern')) {
        throw new Error('Message AST is not of type: "messageFormatPattern"');
      }

      var elements = ast.elements;
      var pattern = elements.filter(function (el) {
        return el.type === 'messageTextElement' || el.type === 'argumentElement';
      }).map(function (el) {
        return el.type === 'messageTextElement' ? _this.compileMessageText(el) : _this.compileArgument(el);
      });

      if (pattern.length !== elements.length) {
        throw new Error('Message element does not have a valid type');
      }

      return pattern;
    };

    Compiler.prototype.compileMessageText = function (element) {
      // When this `element` is part of plural sub-pattern and its value contains
      // an unescaped '#', use a `PluralOffsetString` helper to properly output
      // the number with the correct offset in the string.
      if (this.currentPlural && /(^|[^\\])#/g.test(element.value)) {
        // Create a cache a NumberFormat instance that can be reused for any
        // PluralOffsetString instance in this message.
        if (!this.pluralNumberFormat) {
          this.pluralNumberFormat = new Intl.NumberFormat(this.locales);
        }

        return new PluralOffsetString(this.currentPlural.id, this.currentPlural.format.offset, this.pluralNumberFormat, element.value);
      } // Unescape the escaped '#'s in the message text.


      return element.value.replace(/\\#/g, '#');
    };

    Compiler.prototype.compileArgument = function (element) {
      var format = element.format,
          id = element.id;

      if (!format) {
        return new StringFormat(id);
      }

      var _a = this,
          formats = _a.formats,
          locales = _a.locales;

      switch (format.type) {
        case 'numberFormat':
          return {
            id: id,
            format: new Intl.NumberFormat(locales, formats.number[format.style]).format
          };

        case 'dateFormat':
          return {
            id: id,
            format: new Intl.DateTimeFormat(locales, formats.date[format.style]).format
          };

        case 'timeFormat':
          return {
            id: id,
            format: new Intl.DateTimeFormat(locales, formats.time[format.style]).format
          };

        case 'pluralFormat':
          return new PluralFormat(id, format.ordinal, format.offset, this.compileOptions(element), locales);

        case 'selectFormat':
          return new SelectFormat(id, this.compileOptions(element));

        default:
          throw new Error('Message element does not have a valid format type');
      }
    };

    Compiler.prototype.compileOptions = function (element) {
      var _this = this;

      var format = element.format;
      var options = format.options; // Save the current plural element, if any, then set it to a new value when
      // compiling the options sub-patterns. This conforms the spec's algorithm
      // for handling `"#"` syntax in message text.

      this.pluralStack.push(this.currentPlural);
      this.currentPlural = format.type === 'pluralFormat' ? element : null;
      var optionsHash = options.reduce(function (all, option) {
        // Compile the sub-pattern and save it under the options's selector.
        all[option.selector] = _this.compileMessage(option.value);
        return all;
      }, {}); // Pop the plural stack to put back the original current plural value.

      this.currentPlural = this.pluralStack.pop();
      return optionsHash;
    };

    return Compiler;
  }();

  var Formatter =
  /** @class */
  function () {
    function Formatter(id) {
      this.id = id;
    }

    return Formatter;
  }();

  var StringFormat =
  /** @class */
  function (_super) {
    __extends(StringFormat, _super);

    function StringFormat() {
      return _super !== null && _super.apply(this, arguments) || this;
    }

    StringFormat.prototype.format = function (value) {
      if (!value && typeof value !== 'number') {
        return '';
      }

      return typeof value === 'string' ? value : String(value);
    };

    return StringFormat;
  }(Formatter);

  var PluralFormat =
  /** @class */
  function () {
    function PluralFormat(id, useOrdinal, offset, options, locales) {
      this.id = id;
      this.offset = offset;
      this.options = options;
      this.pluralRules = new Intl.PluralRules(locales, {
        type: useOrdinal ? 'ordinal' : 'cardinal'
      });
    }

    PluralFormat.prototype.getOption = function (value) {
      var options = this.options;
      var option = options['=' + value] || options[this.pluralRules.select(value - this.offset)];
      return option || options.other;
    };

    return PluralFormat;
  }();

  var PluralOffsetString =
  /** @class */
  function (_super) {
    __extends(PluralOffsetString, _super);

    function PluralOffsetString(id, offset, numberFormat, string) {
      var _this = _super.call(this, id) || this;

      _this.offset = offset;
      _this.numberFormat = numberFormat;
      _this.string = string;
      return _this;
    }

    PluralOffsetString.prototype.format = function (value) {
      var number = this.numberFormat.format(value - this.offset);
      return this.string.replace(/(^|[^\\])#/g, '$1' + number).replace(/\\#/g, '#');
    };

    return PluralOffsetString;
  }(Formatter);

  var SelectFormat =
  /** @class */
  function () {
    function SelectFormat(id, options) {
      this.id = id;
      this.options = options;
    }

    SelectFormat.prototype.getOption = function (value) {
      var options = this.options;
      return options[value] || options.other;
    };

    return SelectFormat;
  }();
  function isSelectOrPluralFormat(f) {
    return !!f.options;
  }

  var parser = /*
  * Generated by PEG.js 0.10.0.
  *
  * http://pegjs.org/
  */
  (function () {

    function peg$subclass(child, parent) {
      function ctor() {
        this.constructor = child;
      }

      ctor.prototype = parent.prototype;
      child.prototype = new ctor();
    }

    function peg$SyntaxError(message, expected, found, location) {
      this.message = message;
      this.expected = expected;
      this.found = found;
      this.location = location;
      this.name = "SyntaxError";

      if (typeof Error.captureStackTrace === "function") {
        Error.captureStackTrace(this, peg$SyntaxError);
      }
    }

    peg$subclass(peg$SyntaxError, Error);

    peg$SyntaxError.buildMessage = function (expected, found) {
      var DESCRIBE_EXPECTATION_FNS = {
        literal: function (expectation) {
          return "\"" + literalEscape(expectation.text) + "\"";
        },
        "class": function (expectation) {
          var escapedParts = "",
              i;

          for (i = 0; i < expectation.parts.length; i++) {
            escapedParts += expectation.parts[i] instanceof Array ? classEscape(expectation.parts[i][0]) + "-" + classEscape(expectation.parts[i][1]) : classEscape(expectation.parts[i]);
          }

          return "[" + (expectation.inverted ? "^" : "") + escapedParts + "]";
        },
        any: function (expectation) {
          return "any character";
        },
        end: function (expectation) {
          return "end of input";
        },
        other: function (expectation) {
          return expectation.description;
        }
      };

      function hex(ch) {
        return ch.charCodeAt(0).toString(16).toUpperCase();
      }

      function literalEscape(s) {
        return s.replace(/\\/g, '\\\\').replace(/"/g, '\\"').replace(/\0/g, '\\0').replace(/\t/g, '\\t').replace(/\n/g, '\\n').replace(/\r/g, '\\r').replace(/[\x00-\x0F]/g, function (ch) {
          return '\\x0' + hex(ch);
        }).replace(/[\x10-\x1F\x7F-\x9F]/g, function (ch) {
          return '\\x' + hex(ch);
        });
      }

      function classEscape(s) {
        return s.replace(/\\/g, '\\\\').replace(/\]/g, '\\]').replace(/\^/g, '\\^').replace(/-/g, '\\-').replace(/\0/g, '\\0').replace(/\t/g, '\\t').replace(/\n/g, '\\n').replace(/\r/g, '\\r').replace(/[\x00-\x0F]/g, function (ch) {
          return '\\x0' + hex(ch);
        }).replace(/[\x10-\x1F\x7F-\x9F]/g, function (ch) {
          return '\\x' + hex(ch);
        });
      }

      function describeExpectation(expectation) {
        return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
      }

      function describeExpected(expected) {
        var descriptions = new Array(expected.length),
            i,
            j;

        for (i = 0; i < expected.length; i++) {
          descriptions[i] = describeExpectation(expected[i]);
        }

        descriptions.sort();

        if (descriptions.length > 0) {
          for (i = 1, j = 1; i < descriptions.length; i++) {
            if (descriptions[i - 1] !== descriptions[i]) {
              descriptions[j] = descriptions[i];
              j++;
            }
          }

          descriptions.length = j;
        }

        switch (descriptions.length) {
          case 1:
            return descriptions[0];

          case 2:
            return descriptions[0] + " or " + descriptions[1];

          default:
            return descriptions.slice(0, -1).join(", ") + ", or " + descriptions[descriptions.length - 1];
        }
      }

      function describeFound(found) {
        return found ? "\"" + literalEscape(found) + "\"" : "end of input";
      }

      return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
    };

    function peg$parse(input, options) {
      options = options !== void 0 ? options : {};

      var peg$FAILED = {},
          peg$startRuleFunctions = {
        start: peg$parsestart
      },
          peg$startRuleFunction = peg$parsestart,
          peg$c0 = function (elements) {
        return {
          type: 'messageFormatPattern',
          elements: elements,
          location: location()
        };
      },
          peg$c1 = function (chunks) {
        return chunks.reduce(function (all, chunk) {
          return all.concat(chunk);
        }, []).join('');
      },
          peg$c2 = function (messageText) {
        return {
          type: 'messageTextElement',
          value: messageText,
          location: location()
        };
      },
          peg$c3 = /^[^ \t\n\r,.+={}#]/,
          peg$c4 = peg$classExpectation([" ", "\t", "\n", "\r", ",", ".", "+", "=", "{", "}", "#"], true, false),
          peg$c5 = "{",
          peg$c6 = peg$literalExpectation("{", false),
          peg$c7 = ",",
          peg$c8 = peg$literalExpectation(",", false),
          peg$c9 = "}",
          peg$c10 = peg$literalExpectation("}", false),
          peg$c11 = function (id, format) {
        return {
          type: 'argumentElement',
          id: id,
          format: format && format[2],
          location: location()
        };
      },
          peg$c12 = "number",
          peg$c13 = peg$literalExpectation("number", false),
          peg$c14 = "date",
          peg$c15 = peg$literalExpectation("date", false),
          peg$c16 = "time",
          peg$c17 = peg$literalExpectation("time", false),
          peg$c18 = function (type, style) {
        return {
          type: type + 'Format',
          style: style && style[2],
          location: location()
        };
      },
          peg$c19 = "plural",
          peg$c20 = peg$literalExpectation("plural", false),
          peg$c21 = function (pluralStyle) {
        return {
          type: pluralStyle.type,
          ordinal: false,
          offset: pluralStyle.offset || 0,
          options: pluralStyle.options,
          location: location()
        };
      },
          peg$c22 = "selectordinal",
          peg$c23 = peg$literalExpectation("selectordinal", false),
          peg$c24 = function (pluralStyle) {
        return {
          type: pluralStyle.type,
          ordinal: true,
          offset: pluralStyle.offset || 0,
          options: pluralStyle.options,
          location: location()
        };
      },
          peg$c25 = "select",
          peg$c26 = peg$literalExpectation("select", false),
          peg$c27 = function (options) {
        return {
          type: 'selectFormat',
          options: options,
          location: location()
        };
      },
          peg$c28 = "=",
          peg$c29 = peg$literalExpectation("=", false),
          peg$c30 = function (selector, pattern) {
        return {
          type: 'optionalFormatPattern',
          selector: selector,
          value: pattern,
          location: location()
        };
      },
          peg$c31 = "offset:",
          peg$c32 = peg$literalExpectation("offset:", false),
          peg$c33 = function (number) {
        return number;
      },
          peg$c34 = function (offset, options) {
        return {
          type: 'pluralFormat',
          offset: offset,
          options: options,
          location: location()
        };
      },
          peg$c35 = peg$otherExpectation("whitespace"),
          peg$c36 = /^[ \t\n\r]/,
          peg$c37 = peg$classExpectation([" ", "\t", "\n", "\r"], false, false),
          peg$c38 = peg$otherExpectation("optionalWhitespace"),
          peg$c39 = /^[0-9]/,
          peg$c40 = peg$classExpectation([["0", "9"]], false, false),
          peg$c41 = /^[0-9a-f]/i,
          peg$c42 = peg$classExpectation([["0", "9"], ["a", "f"]], false, true),
          peg$c43 = "0",
          peg$c44 = peg$literalExpectation("0", false),
          peg$c45 = /^[1-9]/,
          peg$c46 = peg$classExpectation([["1", "9"]], false, false),
          peg$c47 = function (digits) {
        return parseInt(digits, 10);
      },
          peg$c48 = /^[^{}\\\0-\x1F\x7F \t\n\r]/,
          peg$c49 = peg$classExpectation(["{", "}", "\\", ["\0", "\x1F"], "\x7F", " ", "\t", "\n", "\r"], true, false),
          peg$c50 = "\\\\",
          peg$c51 = peg$literalExpectation("\\\\", false),
          peg$c52 = function () {
        return '\\';
      },
          peg$c53 = "\\#",
          peg$c54 = peg$literalExpectation("\\#", false),
          peg$c55 = function () {
        return '\\#';
      },
          peg$c56 = "\\{",
          peg$c57 = peg$literalExpectation("\\{", false),
          peg$c58 = function () {
        return '\u007B';
      },
          peg$c59 = "\\}",
          peg$c60 = peg$literalExpectation("\\}", false),
          peg$c61 = function () {
        return '\u007D';
      },
          peg$c62 = "\\u",
          peg$c63 = peg$literalExpectation("\\u", false),
          peg$c64 = function (digits) {
        return String.fromCharCode(parseInt(digits, 16));
      },
          peg$c65 = function (chars) {
        return chars.join('');
      },
          peg$currPos = 0,
          peg$savedPos = 0,
          peg$posDetailsCache = [{
        line: 1,
        column: 1
      }],
          peg$maxFailPos = 0,
          peg$maxFailExpected = [],
          peg$silentFails = 0,
          peg$result;

      if ("startRule" in options) {
        if (!(options.startRule in peg$startRuleFunctions)) {
          throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
        }

        peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
      }

      function location() {
        return peg$computeLocation(peg$savedPos, peg$currPos);
      }

      function peg$literalExpectation(text, ignoreCase) {
        return {
          type: "literal",
          text: text,
          ignoreCase: ignoreCase
        };
      }

      function peg$classExpectation(parts, inverted, ignoreCase) {
        return {
          type: "class",
          parts: parts,
          inverted: inverted,
          ignoreCase: ignoreCase
        };
      }

      function peg$endExpectation() {
        return {
          type: "end"
        };
      }

      function peg$otherExpectation(description) {
        return {
          type: "other",
          description: description
        };
      }

      function peg$computePosDetails(pos) {
        var details = peg$posDetailsCache[pos],
            p;

        if (details) {
          return details;
        } else {
          p = pos - 1;

          while (!peg$posDetailsCache[p]) {
            p--;
          }

          details = peg$posDetailsCache[p];
          details = {
            line: details.line,
            column: details.column
          };

          while (p < pos) {
            if (input.charCodeAt(p) === 10) {
              details.line++;
              details.column = 1;
            } else {
              details.column++;
            }

            p++;
          }

          peg$posDetailsCache[pos] = details;
          return details;
        }
      }

      function peg$computeLocation(startPos, endPos) {
        var startPosDetails = peg$computePosDetails(startPos),
            endPosDetails = peg$computePosDetails(endPos);
        return {
          start: {
            offset: startPos,
            line: startPosDetails.line,
            column: startPosDetails.column
          },
          end: {
            offset: endPos,
            line: endPosDetails.line,
            column: endPosDetails.column
          }
        };
      }

      function peg$fail(expected) {
        if (peg$currPos < peg$maxFailPos) {
          return;
        }

        if (peg$currPos > peg$maxFailPos) {
          peg$maxFailPos = peg$currPos;
          peg$maxFailExpected = [];
        }

        peg$maxFailExpected.push(expected);
      }

      function peg$buildStructuredError(expected, found, location) {
        return new peg$SyntaxError(peg$SyntaxError.buildMessage(expected, found), expected, found, location);
      }

      function peg$parsestart() {
        var s0;
        s0 = peg$parsemessageFormatPattern();
        return s0;
      }

      function peg$parsemessageFormatPattern() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parsemessageFormatElement();

        while (s2 !== peg$FAILED) {
          s1.push(s2);
          s2 = peg$parsemessageFormatElement();
        }

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c0(s1);
        }

        s0 = s1;
        return s0;
      }

      function peg$parsemessageFormatElement() {
        var s0;
        s0 = peg$parsemessageTextElement();

        if (s0 === peg$FAILED) {
          s0 = peg$parseargumentElement();
        }

        return s0;
      }

      function peg$parsemessageText() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$currPos;
        s3 = peg$parse_();

        if (s3 !== peg$FAILED) {
          s4 = peg$parsechars();

          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();

            if (s5 !== peg$FAILED) {
              s3 = [s3, s4, s5];
              s2 = s3;
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }

        if (s2 !== peg$FAILED) {
          while (s2 !== peg$FAILED) {
            s1.push(s2);
            s2 = peg$currPos;
            s3 = peg$parse_();

            if (s3 !== peg$FAILED) {
              s4 = peg$parsechars();

              if (s4 !== peg$FAILED) {
                s5 = peg$parse_();

                if (s5 !== peg$FAILED) {
                  s3 = [s3, s4, s5];
                  s2 = s3;
                } else {
                  peg$currPos = s2;
                  s2 = peg$FAILED;
                }
              } else {
                peg$currPos = s2;
                s2 = peg$FAILED;
              }
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
          }
        } else {
          s1 = peg$FAILED;
        }

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c1(s1);
        }

        s0 = s1;

        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parsews();

          if (s1 !== peg$FAILED) {
            s0 = input.substring(s0, peg$currPos);
          } else {
            s0 = s1;
          }
        }

        return s0;
      }

      function peg$parsemessageTextElement() {
        var s0, s1;
        s0 = peg$currPos;
        s1 = peg$parsemessageText();

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c2(s1);
        }

        s0 = s1;
        return s0;
      }

      function peg$parseargument() {
        var s0, s1, s2;
        s0 = peg$parsenumber();

        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = [];

          if (peg$c3.test(input.charAt(peg$currPos))) {
            s2 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s2 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c4);
            }
          }

          if (s2 !== peg$FAILED) {
            while (s2 !== peg$FAILED) {
              s1.push(s2);

              if (peg$c3.test(input.charAt(peg$currPos))) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
              } else {
                s2 = peg$FAILED;

                if (peg$silentFails === 0) {
                  peg$fail(peg$c4);
                }
              }
            }
          } else {
            s1 = peg$FAILED;
          }

          if (s1 !== peg$FAILED) {
            s0 = input.substring(s0, peg$currPos);
          } else {
            s0 = s1;
          }
        }

        return s0;
      }

      function peg$parseargumentElement() {
        var s0, s1, s2, s3, s4, s5, s6, s7, s8;
        s0 = peg$currPos;

        if (input.charCodeAt(peg$currPos) === 123) {
          s1 = peg$c5;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c6);
          }
        }

        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();

          if (s2 !== peg$FAILED) {
            s3 = peg$parseargument();

            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();

              if (s4 !== peg$FAILED) {
                s5 = peg$currPos;

                if (input.charCodeAt(peg$currPos) === 44) {
                  s6 = peg$c7;
                  peg$currPos++;
                } else {
                  s6 = peg$FAILED;

                  if (peg$silentFails === 0) {
                    peg$fail(peg$c8);
                  }
                }

                if (s6 !== peg$FAILED) {
                  s7 = peg$parse_();

                  if (s7 !== peg$FAILED) {
                    s8 = peg$parseelementFormat();

                    if (s8 !== peg$FAILED) {
                      s6 = [s6, s7, s8];
                      s5 = s6;
                    } else {
                      peg$currPos = s5;
                      s5 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s5;
                    s5 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s5;
                  s5 = peg$FAILED;
                }

                if (s5 === peg$FAILED) {
                  s5 = null;
                }

                if (s5 !== peg$FAILED) {
                  s6 = peg$parse_();

                  if (s6 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 125) {
                      s7 = peg$c9;
                      peg$currPos++;
                    } else {
                      s7 = peg$FAILED;

                      if (peg$silentFails === 0) {
                        peg$fail(peg$c10);
                      }
                    }

                    if (s7 !== peg$FAILED) {
                      peg$savedPos = s0;
                      s1 = peg$c11(s3, s5);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }

        return s0;
      }

      function peg$parseelementFormat() {
        var s0;
        s0 = peg$parsesimpleFormat();

        if (s0 === peg$FAILED) {
          s0 = peg$parsepluralFormat();

          if (s0 === peg$FAILED) {
            s0 = peg$parseselectOrdinalFormat();

            if (s0 === peg$FAILED) {
              s0 = peg$parseselectFormat();
            }
          }
        }

        return s0;
      }

      function peg$parsesimpleFormat() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;

        if (input.substr(peg$currPos, 6) === peg$c12) {
          s1 = peg$c12;
          peg$currPos += 6;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c13);
          }
        }

        if (s1 === peg$FAILED) {
          if (input.substr(peg$currPos, 4) === peg$c14) {
            s1 = peg$c14;
            peg$currPos += 4;
          } else {
            s1 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c15);
            }
          }

          if (s1 === peg$FAILED) {
            if (input.substr(peg$currPos, 4) === peg$c16) {
              s1 = peg$c16;
              peg$currPos += 4;
            } else {
              s1 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c17);
              }
            }
          }
        }

        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();

          if (s2 !== peg$FAILED) {
            s3 = peg$currPos;

            if (input.charCodeAt(peg$currPos) === 44) {
              s4 = peg$c7;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c8);
              }
            }

            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();

              if (s5 !== peg$FAILED) {
                s6 = peg$parsechars();

                if (s6 !== peg$FAILED) {
                  s4 = [s4, s5, s6];
                  s3 = s4;
                } else {
                  peg$currPos = s3;
                  s3 = peg$FAILED;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }

            if (s3 === peg$FAILED) {
              s3 = null;
            }

            if (s3 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c18(s1, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }

        return s0;
      }

      function peg$parsepluralFormat() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;

        if (input.substr(peg$currPos, 6) === peg$c19) {
          s1 = peg$c19;
          peg$currPos += 6;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c20);
          }
        }

        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();

          if (s2 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s3 = peg$c7;
              peg$currPos++;
            } else {
              s3 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c8);
              }
            }

            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();

              if (s4 !== peg$FAILED) {
                s5 = peg$parsepluralStyle();

                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$c21(s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }

        return s0;
      }

      function peg$parseselectOrdinalFormat() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;

        if (input.substr(peg$currPos, 13) === peg$c22) {
          s1 = peg$c22;
          peg$currPos += 13;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c23);
          }
        }

        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();

          if (s2 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s3 = peg$c7;
              peg$currPos++;
            } else {
              s3 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c8);
              }
            }

            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();

              if (s4 !== peg$FAILED) {
                s5 = peg$parsepluralStyle();

                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$c24(s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }

        return s0;
      }

      function peg$parseselectFormat() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;

        if (input.substr(peg$currPos, 6) === peg$c25) {
          s1 = peg$c25;
          peg$currPos += 6;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c26);
          }
        }

        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();

          if (s2 !== peg$FAILED) {
            if (input.charCodeAt(peg$currPos) === 44) {
              s3 = peg$c7;
              peg$currPos++;
            } else {
              s3 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c8);
              }
            }

            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();

              if (s4 !== peg$FAILED) {
                s5 = [];
                s6 = peg$parseoptionalFormatPattern();

                if (s6 !== peg$FAILED) {
                  while (s6 !== peg$FAILED) {
                    s5.push(s6);
                    s6 = peg$parseoptionalFormatPattern();
                  }
                } else {
                  s5 = peg$FAILED;
                }

                if (s5 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$c27(s5);
                  s0 = s1;
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }

        return s0;
      }

      function peg$parseselector() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;
        s1 = peg$currPos;

        if (input.charCodeAt(peg$currPos) === 61) {
          s2 = peg$c28;
          peg$currPos++;
        } else {
          s2 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c29);
          }
        }

        if (s2 !== peg$FAILED) {
          s3 = peg$parsenumber();

          if (s3 !== peg$FAILED) {
            s2 = [s2, s3];
            s1 = s2;
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }

        if (s1 !== peg$FAILED) {
          s0 = input.substring(s0, peg$currPos);
        } else {
          s0 = s1;
        }

        if (s0 === peg$FAILED) {
          s0 = peg$parsechars();
        }

        return s0;
      }

      function peg$parseoptionalFormatPattern() {
        var s0, s1, s2, s3, s4, s5, s6;
        s0 = peg$currPos;
        s1 = peg$parse_();

        if (s1 !== peg$FAILED) {
          s2 = peg$parseselector();

          if (s2 !== peg$FAILED) {
            s3 = peg$parse_();

            if (s3 !== peg$FAILED) {
              if (input.charCodeAt(peg$currPos) === 123) {
                s4 = peg$c5;
                peg$currPos++;
              } else {
                s4 = peg$FAILED;

                if (peg$silentFails === 0) {
                  peg$fail(peg$c6);
                }
              }

              if (s4 !== peg$FAILED) {
                s5 = peg$parsemessageFormatPattern();

                if (s5 !== peg$FAILED) {
                  if (input.charCodeAt(peg$currPos) === 125) {
                    s6 = peg$c9;
                    peg$currPos++;
                  } else {
                    s6 = peg$FAILED;

                    if (peg$silentFails === 0) {
                      peg$fail(peg$c10);
                    }
                  }

                  if (s6 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$c30(s2, s5);
                    s0 = s1;
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }

        return s0;
      }

      function peg$parseoffset() {
        var s0, s1, s2, s3;
        s0 = peg$currPos;

        if (input.substr(peg$currPos, 7) === peg$c31) {
          s1 = peg$c31;
          peg$currPos += 7;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c32);
          }
        }

        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();

          if (s2 !== peg$FAILED) {
            s3 = peg$parsenumber();

            if (s3 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c33(s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }

        return s0;
      }

      function peg$parsepluralStyle() {
        var s0, s1, s2, s3, s4;
        s0 = peg$currPos;
        s1 = peg$parseoffset();

        if (s1 === peg$FAILED) {
          s1 = null;
        }

        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();

          if (s2 !== peg$FAILED) {
            s3 = [];
            s4 = peg$parseoptionalFormatPattern();

            if (s4 !== peg$FAILED) {
              while (s4 !== peg$FAILED) {
                s3.push(s4);
                s4 = peg$parseoptionalFormatPattern();
              }
            } else {
              s3 = peg$FAILED;
            }

            if (s3 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c34(s1, s3);
              s0 = s1;
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }

        return s0;
      }

      function peg$parsews() {
        var s0, s1;
        peg$silentFails++;
        s0 = [];

        if (peg$c36.test(input.charAt(peg$currPos))) {
          s1 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c37);
          }
        }

        if (s1 !== peg$FAILED) {
          while (s1 !== peg$FAILED) {
            s0.push(s1);

            if (peg$c36.test(input.charAt(peg$currPos))) {
              s1 = input.charAt(peg$currPos);
              peg$currPos++;
            } else {
              s1 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c37);
              }
            }
          }
        } else {
          s0 = peg$FAILED;
        }

        peg$silentFails--;

        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c35);
          }
        }

        return s0;
      }

      function peg$parse_() {
        var s0, s1, s2;
        peg$silentFails++;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parsews();

        while (s2 !== peg$FAILED) {
          s1.push(s2);
          s2 = peg$parsews();
        }

        if (s1 !== peg$FAILED) {
          s0 = input.substring(s0, peg$currPos);
        } else {
          s0 = s1;
        }

        peg$silentFails--;

        if (s0 === peg$FAILED) {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c38);
          }
        }

        return s0;
      }

      function peg$parsedigit() {
        var s0;

        if (peg$c39.test(input.charAt(peg$currPos))) {
          s0 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s0 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c40);
          }
        }

        return s0;
      }

      function peg$parsehexDigit() {
        var s0;

        if (peg$c41.test(input.charAt(peg$currPos))) {
          s0 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s0 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c42);
          }
        }

        return s0;
      }

      function peg$parsenumber() {
        var s0, s1, s2, s3, s4, s5;
        s0 = peg$currPos;

        if (input.charCodeAt(peg$currPos) === 48) {
          s1 = peg$c43;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c44);
          }
        }

        if (s1 === peg$FAILED) {
          s1 = peg$currPos;
          s2 = peg$currPos;

          if (peg$c45.test(input.charAt(peg$currPos))) {
            s3 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s3 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c46);
            }
          }

          if (s3 !== peg$FAILED) {
            s4 = [];
            s5 = peg$parsedigit();

            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = peg$parsedigit();
            }

            if (s4 !== peg$FAILED) {
              s3 = [s3, s4];
              s2 = s3;
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }

          if (s2 !== peg$FAILED) {
            s1 = input.substring(s1, peg$currPos);
          } else {
            s1 = s2;
          }
        }

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c47(s1);
        }

        s0 = s1;
        return s0;
      }

      function peg$parsechar() {
        var s0, s1, s2, s3, s4, s5, s6, s7;

        if (peg$c48.test(input.charAt(peg$currPos))) {
          s0 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s0 = peg$FAILED;

          if (peg$silentFails === 0) {
            peg$fail(peg$c49);
          }
        }

        if (s0 === peg$FAILED) {
          s0 = peg$currPos;

          if (input.substr(peg$currPos, 2) === peg$c50) {
            s1 = peg$c50;
            peg$currPos += 2;
          } else {
            s1 = peg$FAILED;

            if (peg$silentFails === 0) {
              peg$fail(peg$c51);
            }
          }

          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$c52();
          }

          s0 = s1;

          if (s0 === peg$FAILED) {
            s0 = peg$currPos;

            if (input.substr(peg$currPos, 2) === peg$c53) {
              s1 = peg$c53;
              peg$currPos += 2;
            } else {
              s1 = peg$FAILED;

              if (peg$silentFails === 0) {
                peg$fail(peg$c54);
              }
            }

            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$c55();
            }

            s0 = s1;

            if (s0 === peg$FAILED) {
              s0 = peg$currPos;

              if (input.substr(peg$currPos, 2) === peg$c56) {
                s1 = peg$c56;
                peg$currPos += 2;
              } else {
                s1 = peg$FAILED;

                if (peg$silentFails === 0) {
                  peg$fail(peg$c57);
                }
              }

              if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$c58();
              }

              s0 = s1;

              if (s0 === peg$FAILED) {
                s0 = peg$currPos;

                if (input.substr(peg$currPos, 2) === peg$c59) {
                  s1 = peg$c59;
                  peg$currPos += 2;
                } else {
                  s1 = peg$FAILED;

                  if (peg$silentFails === 0) {
                    peg$fail(peg$c60);
                  }
                }

                if (s1 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$c61();
                }

                s0 = s1;

                if (s0 === peg$FAILED) {
                  s0 = peg$currPos;

                  if (input.substr(peg$currPos, 2) === peg$c62) {
                    s1 = peg$c62;
                    peg$currPos += 2;
                  } else {
                    s1 = peg$FAILED;

                    if (peg$silentFails === 0) {
                      peg$fail(peg$c63);
                    }
                  }

                  if (s1 !== peg$FAILED) {
                    s2 = peg$currPos;
                    s3 = peg$currPos;
                    s4 = peg$parsehexDigit();

                    if (s4 !== peg$FAILED) {
                      s5 = peg$parsehexDigit();

                      if (s5 !== peg$FAILED) {
                        s6 = peg$parsehexDigit();

                        if (s6 !== peg$FAILED) {
                          s7 = peg$parsehexDigit();

                          if (s7 !== peg$FAILED) {
                            s4 = [s4, s5, s6, s7];
                            s3 = s4;
                          } else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s3;
                          s3 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s3;
                        s3 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s3;
                      s3 = peg$FAILED;
                    }

                    if (s3 !== peg$FAILED) {
                      s2 = input.substring(s2, peg$currPos);
                    } else {
                      s2 = s3;
                    }

                    if (s2 !== peg$FAILED) {
                      peg$savedPos = s0;
                      s1 = peg$c64(s2);
                      s0 = s1;
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                }
              }
            }
          }
        }

        return s0;
      }

      function peg$parsechars() {
        var s0, s1, s2;
        s0 = peg$currPos;
        s1 = [];
        s2 = peg$parsechar();

        if (s2 !== peg$FAILED) {
          while (s2 !== peg$FAILED) {
            s1.push(s2);
            s2 = peg$parsechar();
          }
        } else {
          s1 = peg$FAILED;
        }

        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$c65(s1);
        }

        s0 = s1;
        return s0;
      }

      peg$result = peg$startRuleFunction();

      if (peg$result !== peg$FAILED && peg$currPos === input.length) {
        return peg$result;
      } else {
        if (peg$result !== peg$FAILED && peg$currPos < input.length) {
          peg$fail(peg$endExpectation());
        }

        throw peg$buildStructuredError(peg$maxFailExpected, peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null, peg$maxFailPos < input.length ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1) : peg$computeLocation(peg$maxFailPos, peg$maxFailPos));
      }
    }

    return {
      SyntaxError: peg$SyntaxError,
      parse: peg$parse
    };
  })();

  /*
  Copyright (c) 2014, Yahoo! Inc. All rights reserved.
  Copyrights licensed under the New BSD License.
  See the accompanying LICENSE file for terms.
  */
  var __extends$1 = undefined && undefined.__extends || function () {
    var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf || {
        __proto__: []
      } instanceof Array && function (d, b) {
        d.__proto__ = b;
      } || function (d, b) {
        for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
      };

      return extendStatics(d, b);
    };

    return function (d, b) {
      extendStatics(d, b);

      function __() {
        this.constructor = d;
      }

      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
  }();

  var __assign = undefined && undefined.__assign || function () {
    __assign = Object.assign || function (t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];

        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }

      return t;
    };

    return __assign.apply(this, arguments);
  };

  function resolveLocale(locales) {
    if (typeof locales === 'string') {
      locales = [locales];
    }

    try {
      return Intl.NumberFormat.supportedLocalesOf(locales, {
        // IE11 localeMatcher `lookup` seems to convert `en` -> `en-US`
        // but not other browsers,
        localeMatcher: 'best fit'
      })[0];
    } catch (e) {
      return MessageFormat.defaultLocale;
    }
  }

  function formatPatterns(pattern, values) {
    var result = '';

    for (var _i = 0, pattern_1 = pattern; _i < pattern_1.length; _i++) {
      var part = pattern_1[_i]; // Exist early for string parts.

      if (typeof part === 'string') {
        result += part;
        continue;
      }

      var id = part.id; // Enforce that all required values are provided by the caller.

      if (!(values && id in values)) {
        throw new FormatError("A value must be provided for: " + id, id);
      }

      var value = values[id]; // Recursively format plural and select parts' option — which can be a
      // nested pattern structure. The choosing of the option to use is
      // abstracted-by and delegated-to the part helper object.

      if (isSelectOrPluralFormat(part)) {
        result += formatPatterns(part.getOption(value), values);
      } else {
        result += part.format(value);
      }
    }

    return result;
  }

  function mergeConfig(c1, c2) {
    if (!c2) {
      return c1;
    }

    return __assign({}, c1 || {}, c2 || {}, Object.keys(c1).reduce(function (all, k) {
      all[k] = __assign({}, c1[k], c2[k] || {});
      return all;
    }, {}));
  }

  function mergeConfigs(defaultConfig, configs) {
    if (!configs) {
      return defaultConfig;
    }

    return Object.keys(defaultConfig).reduce(function (all, k) {
      all[k] = mergeConfig(defaultConfig[k], configs[k]);
      return all;
    }, __assign({}, defaultConfig));
  }

  var FormatError =
  /** @class */
  function (_super) {
    __extends$1(FormatError, _super);

    function FormatError(msg, variableId) {
      var _this = _super.call(this, msg) || this;

      _this.variableId = variableId;
      return _this;
    }

    return FormatError;
  }(Error);

  var MessageFormat = function (message, locales, overrideFormats) {
    if (locales === void 0) {
      locales = MessageFormat.defaultLocale;
    } // Parse string messages into an AST.


    var ast = typeof message === 'string' ? MessageFormat.__parse(message) : message;

    if (!(ast && ast.type === 'messageFormatPattern')) {
      throw new TypeError('A message must be provided as a String or AST.');
    } // Creates a new object with the specified `formats` merged with the default
    // formats.


    var formats = mergeConfigs(MessageFormat.formats, overrideFormats); // Defined first because it's used to build the format pattern.

    var locale = resolveLocale(locales || []); // Compile the `ast` to a pattern that is highly optimized for repeated
    // `format()` invocations. **Note:** This passes the `locales` set provided
    // to the constructor instead of just the resolved locale.

    var pattern = new Compiler(locales, formats).compile(ast); // "Bind" `format()` method to `this` so it can be passed by reference like
    // the other `Intl` APIs.

    return {
      format: function (values) {
        try {
          return formatPatterns(pattern, values);
        } catch (e) {
          if (e.variableId) {
            throw new Error("The intl string context variable '" + e.variableId + "' was not provided to the string '" + message + "'");
          } else {
            throw e;
          }
        }
      },
      resolvedOptions: function () {
        return {
          locale: locale
        };
      },
      getAst: function () {
        return ast;
      }
    };
  };

  MessageFormat.defaultLocale = 'en'; // Default format options used as the prototype of the `formats` provided to the
  // constructor. These are used when constructing the internal Intl.NumberFormat
  // and Intl.DateTimeFormat instances.

  MessageFormat.formats = {
    number: {
      currency: {
        style: 'currency'
      },
      percent: {
        style: 'percent'
      }
    },
    date: {
      short: {
        month: 'numeric',
        day: 'numeric',
        year: '2-digit'
      },
      medium: {
        month: 'short',
        day: 'numeric',
        year: 'numeric'
      },
      long: {
        month: 'long',
        day: 'numeric',
        year: 'numeric'
      },
      full: {
        weekday: 'long',
        month: 'long',
        day: 'numeric',
        year: 'numeric'
      }
    },
    time: {
      short: {
        hour: 'numeric',
        minute: 'numeric'
      },
      medium: {
        hour: 'numeric',
        minute: 'numeric',
        second: 'numeric'
      },
      long: {
        hour: 'numeric',
        minute: 'numeric',
        second: 'numeric',
        timeZoneName: 'short'
      },
      full: {
        hour: 'numeric',
        minute: 'numeric',
        second: 'numeric',
        timeZoneName: 'short'
      }
    }
  };
  MessageFormat.__parse = parser.parse;

  /*
  Copyright (c) 2014, Yahoo! Inc. All rights reserved.
  Copyrights licensed under the New BSD License.
  See the accompanying LICENSE file for terms.
  */
  function daysToYears(days) {
    // 400 years have 146097 days (taking into account leap year rules)
    return days * 400 / 146097;
  } // Thanks to date-fns
  // https://github.com/date-fns/date-fns
  // MIT © Sasha Koss


  var MILLISECONDS_IN_MINUTE = 60000;
  var MILLISECONDS_IN_DAY = 86400000;

  function startOfDay(dirtyDate) {
    var date = new Date(dirtyDate);
    date.setHours(0, 0, 0, 0);
    return date;
  }

  function differenceInCalendarDays(dirtyDateLeft, dirtyDateRight) {
    var startOfDayLeft = startOfDay(dirtyDateLeft);
    var startOfDayRight = startOfDay(dirtyDateRight);
    var timestampLeft = startOfDayLeft.getTime() - startOfDayLeft.getTimezoneOffset() * MILLISECONDS_IN_MINUTE;
    var timestampRight = startOfDayRight.getTime() - startOfDayRight.getTimezoneOffset() * MILLISECONDS_IN_MINUTE; // Round the number of days to the nearest integer
    // because the number of milliseconds in a day is not constant
    // (e.g. it's different in the day of the daylight saving time clock shift)

    return Math.round((timestampLeft - timestampRight) / MILLISECONDS_IN_DAY);
  }

  function diff(from, to) {
    // Convert to ms timestamps.
    from = +from;
    to = +to;
    var millisecond = Math.round(to - from),
        second = Math.round(millisecond / 1000),
        minute = Math.round(second / 60),
        hour = Math.round(minute / 60); // We expect a more precision in rounding when dealing with
    // days as it feels wrong when something happended 13 hours ago and
    // is regarded as "yesterday" even if the time was this morning.

    var day = differenceInCalendarDays(to, from);
    var week = Math.round(day / 7);
    var rawYears = daysToYears(day),
        month = Math.round(rawYears * 12),
        year = Math.round(rawYears);
    return {
      second: second,
      'second-short': second,
      'second-narrow': second,
      minute: minute,
      'minute-short': minute,
      'minute-narrow': minute,
      hour: hour,
      'hour-short': hour,
      'hour-narrow': hour,
      day: day,
      'day-short': day,
      'day-narrow': day,
      week: week,
      'week-short': week,
      'week-narrow': week,
      month: month,
      'month-short': month,
      'month-narrow': month,
      year: year,
      'year-short': year,
      'year-narrow': year
    };
  }

  /*
  Copyright (c) 2014, Yahoo! Inc. All rights reserved.
  Copyrights licensed under the New BSD License.
  See the accompanying LICENSE file for terms.
  */

  var SUPPORTED_FIELDS = ["second"
  /* second */
  , "second-short"
  /* secondShort */
  , "minute"
  /* minute */
  , "minute-short"
  /* minuteShort */
  , "hour"
  /* hour */
  , "hour-short"
  /* hourShort */
  , "day"
  /* day */
  , "day-short"
  /* dayShort */
  , "month"
  /* month */
  , "month-short"
  /* monthShort */
  , "year"
  /* year */
  , "year-short"
  /* yearShort */
  ];

  function isValidUnits(units) {
    if (!units || ~SUPPORTED_FIELDS.indexOf(units)) {
      return true;
    }

    if (typeof units === 'string') {
      var suggestion = /s$/.test(units) && units.substr(0, units.length - 1);

      if (suggestion && ~SUPPORTED_FIELDS.indexOf(suggestion)) {
        throw new Error("\"" + units + "\" is not a valid IntlRelativeFormat 'units' value, did you mean: " + suggestion);
      }
    }

    throw new Error("\"" + units + "\" is not a valid IntlRelativeFormat 'units' value, it must be one of: " + SUPPORTED_FIELDS.join('", "'));
  }

  function resolveStyle(style) {
    // Default to "best fit" style.
    if (!style) {
      return "best fit"
      /* bestFit */
      ;
    }

    if (style === 'best fit' || style === 'numeric') {
      return style;
    }

    throw new Error("\"" + style + "\" is not a valid IntlRelativeFormat 'style' value, it must be one of: 'best fit' or 'numeric'");
  }

  function selectUnits(diffReport) {
    var fields = SUPPORTED_FIELDS.filter(function (field) {
      return field.indexOf('-short') < 1;
    });
    var units = fields[0];

    for (var _i = 0, fields_1 = fields; _i < fields_1.length; _i++) {
      units = fields_1[_i];

      if (Math.abs(diffReport[units]) < RelativeFormat.thresholds[units]) {
        break;
      }
    }

    return units;
  }

  var RelativeFormat = function (locales, options) {
    if (options === void 0) {
      options = {};
    }

    var resolvedOptions = {
      style: resolveStyle(options.style),
      units: isValidUnits(options.units) && options.units
    };
    var numeric = resolvedOptions.style === 'best fit' ? 'auto' : 'always';
    var rtf = new Intl.RelativeTimeFormat(locales, {
      numeric: numeric
    });
    return {
      format: function (date, options) {
        var now = options && options.now !== undefined ? options.now === null ? 0 : options.now : Date.now();

        if (date === undefined) {
          date = now;
        } // Determine if the `date` and optional `now` values are valid, and throw a
        // similar error to what `Intl.DateTimeFormat#format()` would throw.


        if (!isFinite(now)) {
          throw new RangeError('The `now` option provided to IntlRelativeFormat#format() is not ' + 'in valid range.');
        }

        if (!isFinite(date)) {
          throw new RangeError('The date value provided to IntlRelativeFormat#format() is not ' + 'in valid range.');
        }

        var diffReport = diff(now, date);
        var units = resolvedOptions.units || selectUnits(diffReport);
        var diffInUnits = diffReport[units];
        var style = units.substring(units.length - 6, units.length) === '-short' ? 'narrow' : 'long';
        var rtfUnit = units.replace('-short', '');
        return new Intl.RelativeTimeFormat(locales, {
          numeric: numeric,
          style: style
        }).format(diffInUnits, rtfUnit);
      },
      resolvedOptions: function () {
        return {
          locale: rtf.resolvedOptions().locale,
          style: resolvedOptions.style,
          units: resolvedOptions.units
        };
      }
    };
  }; // Define public `defaultLocale` property which can be set by the developer, or
  // it will be set when the first RelativeFormat instance is created by
  // leveraging the resolved locale from `Intl`.


  RelativeFormat.defaultLocale = 'en';
  RelativeFormat.thresholds = {
    second: 45,
    'second-short': 45,
    minute: 45,
    'minute-short': 45,
    hour: 22,
    'hour-short': 22,
    day: 26,
    'day-short': 26,
    month: 11,
    'month-short': 11 // months to year

  };

  /*
  Copyright (c) 2014, Yahoo! Inc. All rights reserved.
  Copyrights licensed under the New BSD License.
  See the accompanying LICENSE file for terms.
  */

  function getCacheId(inputs) {
    return JSON.stringify(inputs.map(function (input) {
      return input && typeof input === 'object' ? orderedProps(input) : input;
    }));
  }

  function orderedProps(obj) {
    return Object.keys(obj).sort().map(function (k) {
      var _a;

      return _a = {}, _a[k] = obj[k], _a;
    });
  }

  var memoizeFormatConstructor = function (FormatConstructor, cache) {
    if (cache === void 0) {
      cache = {};
    }

    return function () {
      var _a;

      var args = [];

      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }

      var cacheId = getCacheId(args);
      var format = cacheId && cache[cacheId];

      if (!format) {
        format = new ((_a = FormatConstructor).bind.apply(_a, [void 0].concat(args)))();

        if (cacheId) {
          cache[cacheId] = format;
        }
      }

      return format;
    };
  };

  var DATE_TIME_FORMAT_OPTIONS = Object.keys(dateTimeFormatPropTypes);
  var NUMBER_FORMAT_OPTIONS = Object.keys(numberFormatPropTypes);
  var RELATIVE_FORMAT_OPTIONS = Object.keys(relativeFormatPropTypes);
  var PLURAL_FORMAT_OPTIONS = Object.keys(pluralFormatPropTypes);
  var RELATIVE_FORMAT_THRESHOLDS = {
    second: 60,
    // seconds to minute
    minute: 60,
    // minutes to hour
    hour: 24,
    // hours to day
    day: 30,
    // days to month
    month: 12 // months to year

  };

  function updateRelativeFormatThresholds(newThresholds) {
    var thresholds = RelativeFormat.thresholds;
    thresholds.second = newThresholds.second;
    thresholds.minute = newThresholds.minute;
    thresholds.hour = newThresholds.hour;
    thresholds.day = newThresholds.day;
    thresholds.month = newThresholds.month;
    thresholds['second-short'] = newThresholds['second-short'];
    thresholds['minute-short'] = newThresholds['minute-short'];
    thresholds['hour-short'] = newThresholds['hour-short'];
    thresholds['day-short'] = newThresholds['day-short'];
    thresholds['month-short'] = newThresholds['month-short'];
  }

  function getNamedFormat(formats, type, name, onError) {
    var format = formats && formats[type] && formats[type][name];

    if (format) {
      return format;
    }

    onError(createError("No ".concat(type, " format named: ").concat(name)));
  }

  function formatDate(config, state, value) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var locale = config.locale,
        formats = config.formats,
        timeZone = config.timeZone;
    var format = options.format;
    var onError = config.onError || defaultErrorHandler;
    var date = new Date(value);

    var defaults = _objectSpread({}, timeZone && {
      timeZone: timeZone
    }, format && getNamedFormat(formats, 'date', format, onError));

    var filteredOptions = filterProps(options, DATE_TIME_FORMAT_OPTIONS, defaults);

    try {
      return state.getDateTimeFormat(locale, filteredOptions).format(date);
    } catch (e) {
      onError(createError('Error formatting date.', e));
    }

    return String(date);
  }
  function formatTime(config, state, value) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var locale = config.locale,
        formats = config.formats,
        timeZone = config.timeZone;
    var format = options.format;
    var onError = config.onError || defaultErrorHandler;
    var date = new Date(value);

    var defaults = _objectSpread({}, timeZone && {
      timeZone: timeZone
    }, format && getNamedFormat(formats, 'time', format, onError));

    var filteredOptions = filterProps(options, DATE_TIME_FORMAT_OPTIONS, defaults);

    if (!filteredOptions.hour && !filteredOptions.minute && !filteredOptions.second) {
      // Add default formatting options if hour, minute, or second isn't defined.
      filteredOptions = _objectSpread({}, filteredOptions, {
        hour: 'numeric',
        minute: 'numeric'
      });
    }

    try {
      return state.getDateTimeFormat(locale, filteredOptions).format(date);
    } catch (e) {
      onError(createError('Error formatting time.', e));
    }

    return String(date);
  }
  function formatRelative(config, state, value) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var locale = config.locale,
        formats = config.formats;
    var format = options.format;
    var onError = config.onError || defaultErrorHandler;
    var date = new Date(value);
    var now = new Date(options.now);
    var defaults = format && getNamedFormat(formats, 'relative', format, onError);
    var filteredOptions = filterProps(options, RELATIVE_FORMAT_OPTIONS, defaults); // Capture the current threshold values, then temporarily override them with
    // specific values just for this render.

    var oldThresholds = _objectSpread({}, RelativeFormat.thresholds);

    updateRelativeFormatThresholds(RELATIVE_FORMAT_THRESHOLDS);

    try {
      return state.getRelativeFormat(locale, filteredOptions).format(date, {
        now: isFinite(now) ? now : state.now()
      });
    } catch (e) {
      onError(createError('Error formatting relative time.', e));
    } finally {
      updateRelativeFormatThresholds(oldThresholds);
    }

    return String(date);
  }
  function formatNumber(config, state, value) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var locale = config.locale,
        formats = config.formats;
    var format = options.format;
    var onError = config.onError || defaultErrorHandler;
    var defaults = format && getNamedFormat(formats, 'number', format, onError);
    var filteredOptions = filterProps(options, NUMBER_FORMAT_OPTIONS, defaults);

    try {
      return state.getNumberFormat(locale, filteredOptions).format(value);
    } catch (e) {
      onError(createError('Error formatting number.', e));
    }

    return String(value);
  }
  function formatPlural(config, state, value) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var locale = config.locale;
    var filteredOptions = filterProps(options, PLURAL_FORMAT_OPTIONS);
    var onError = config.onError || defaultErrorHandler;

    try {
      return state.getPluralRules(locale, filteredOptions).select(value);
    } catch (e) {
      onError(createError('Error formatting plural.', e));
    }

    return 'other';
  }
  function formatMessage(config, state) {
    var messageDescriptor = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var values = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var locale = config.locale,
        formats = config.formats,
        messages = config.messages,
        defaultLocale = config.defaultLocale,
        defaultFormats = config.defaultFormats;
    var id = messageDescriptor.id,
        defaultMessage = messageDescriptor.defaultMessage; // Produce a better error if the user calls `intl.formatMessage(element)`

    {
      invariant_1(!React.isValidElement(config), "[React Intl] Don't pass React elements to " + 'formatMessage(), pass `.props`.');
    } // `id` is a required field of a Message Descriptor.


    invariant_1(id, '[React Intl] An `id` must be provided to format a message.');
    var message = messages && messages[id];
    var hasValues = Object.keys(values).length > 0; // Avoid expensive message formatting for simple messages without values. In
    // development messages will always be formatted in case of missing values.

    if (!hasValues && "development" === 'production') {
      return message || defaultMessage || id;
    }

    var formattedMessage;
    var onError = config.onError || defaultErrorHandler;

    if (message) {
      try {
        var formatter = state.getMessageFormat(message, locale, formats);
        formattedMessage = formatter.format(values);
      } catch (e) {
        onError(createError("Error formatting message: \"".concat(id, "\" for locale: \"").concat(locale, "\"") + (defaultMessage ? ', using default message as fallback.' : ''), e));
      }
    } else {
      // This prevents warnings from littering the console in development
      // when no `messages` are passed into the <IntlProvider> for the
      // default locale, and a default message is in the source.
      if (!defaultMessage || locale && locale.toLowerCase() !== defaultLocale.toLowerCase()) {
        onError(createError("Missing message: \"".concat(id, "\" for locale: \"").concat(locale, "\"") + (defaultMessage ? ', using default message as fallback.' : '')));
      }
    }

    if (!formattedMessage && defaultMessage) {
      try {
        var _formatter = state.getMessageFormat(defaultMessage, defaultLocale, defaultFormats);

        formattedMessage = _formatter.format(values);
      } catch (e) {
        onError(createError("Error formatting the default message for: \"".concat(id, "\""), e));
      }
    }

    if (!formattedMessage) {
      onError(createError("Cannot format message: \"".concat(id, "\", ") + "using message ".concat(message || defaultMessage ? 'source' : 'id', " as fallback.")));
    }

    return formattedMessage || message || defaultMessage || id;
  }
  function formatHTMLMessage(config, state, messageDescriptor) {
    var rawValues = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    // Process all the values before they are used when formatting the ICU
    // Message string. Since the formatted message might be injected via
    // `innerHTML`, all String-based values need to be HTML-escaped.
    var escapedValues = Object.keys(rawValues).reduce(function (escaped, name) {
      var value = rawValues[name];
      escaped[name] = typeof value === 'string' ? escape(value) : value;
      return escaped;
    }, {});
    return formatMessage(config, state, messageDescriptor, escapedValues);
  }

  var format = /*#__PURE__*/Object.freeze({
    formatDate: formatDate,
    formatTime: formatTime,
    formatRelative: formatRelative,
    formatNumber: formatNumber,
    formatPlural: formatPlural,
    formatMessage: formatMessage,
    formatHTMLMessage: formatHTMLMessage
  });

  /*
   * Copyright 2015, Yahoo Inc.
   * Copyrights licensed under the New BSD License.
   * See the accompanying LICENSE file for terms.
   */
  function areIntlLocalesSupported(locales) {
    if (typeof Intl === 'undefined') {
      return false;
    }

    if (!locales) {
      throw new Error('locales must be supplied.');
    }

    if (!Array.isArray(locales)) {
      locales = [locales];
    }

    var intlConstructors = [Intl.Collator, Intl.DateTimeFormat, Intl.NumberFormat].filter(Boolean);

    if (intlConstructors.length === 0) {
      return false;
    }

    return intlConstructors.every(function (intlConstructor) {
      return intlConstructor.supportedLocalesOf(locales).length === locales.length;
    });
  }

  var intlConfigPropNames = Object.keys(intlConfigPropTypes);
  var intlFormatPropNames = Object.keys(intlFormatPropTypes); // These are not a static property on the `IntlProvider` class so the intl
  // config values can be inherited from an <IntlProvider> ancestor.

  var defaultProps = {
    formats: {},
    messages: {},
    timeZone: null,
    textComponent: 'span',
    defaultLocale: 'en',
    defaultFormats: {},
    onError: defaultErrorHandler
  };

  function getConfig(filteredProps) {
    var config = _objectSpread({}, filteredProps); // Apply default props. This must be applied last after the props have
    // been resolved and inherited from any <IntlProvider> in the ancestry.
    // This matches how React resolves `defaultProps`.


    for (var propName in defaultProps) {
      if (config[propName] === undefined) {
        config[propName] = defaultProps[propName];
      }
    }

    if (!config.locale || !areIntlLocalesSupported(config.locale)) {
      var _config = config,
          locale = _config.locale,
          defaultLocale = _config.defaultLocale,
          defaultFormats = _config.defaultFormats,
          onError = _config.onError;
      onError(createError("Missing locale data for locale: \"".concat(locale, "\". ") + "Using default locale: \"".concat(defaultLocale, "\" as fallback."))); // Since there's no registered locale data for `locale`, this will
      // fallback to the `defaultLocale` to make sure things can render.
      // The `messages` are overridden to the `defaultProps` empty object
      // to maintain referential equality across re-renders. It's assumed
      // each <FormattedMessage> contains a `defaultMessage` prop.

      config = _objectSpread({}, config, {
        locale: defaultLocale,
        formats: defaultFormats,
        messages: defaultProps.messages
      });
    }

    return config;
  }

  function getBoundFormatFns(config, state) {
    var formatterState = _objectSpread({}, state.context.formatters, {
      now: state.context.now
    });

    return intlFormatPropNames.reduce(function (boundFormatFns, name) {
      boundFormatFns[name] = format[name].bind(null, config, formatterState);
      return boundFormatFns;
    }, {});
  }

  var IntlProvider$1 =
  /*#__PURE__*/
  function (_Component) {
    _inherits(IntlProvider, _Component);

    function IntlProvider(props) {
      var _this;

      _classCallCheck(this, IntlProvider);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(IntlProvider).call(this, props));
      invariant_1(typeof Intl !== 'undefined', '[React Intl] The `Intl` APIs must be available in the runtime, ' + 'and do not appear to be built-in. An `Intl` polyfill should be loaded.\n' + 'See: http://formatjs.io/guides/runtime-environments/');
      var intlContext = props.intl; // Used to stabilize time when performing an initial rendering so that
      // all relative times use the same reference "now" time.

      var initialNow;

      if (isFinite(props.initialNow)) {
        initialNow = Number(props.initialNow);
      } else {
        // When an `initialNow` isn't provided via `props`, look to see an
        // <IntlProvider> exists in the ancestry and call its `now()`
        // function to propagate its value for "now".
        initialNow = intlContext ? intlContext.now() : Date.now();
      } // Creating `Intl*` formatters is expensive. If there's a parent
      // `<IntlProvider>`, then its formatters will be used. Otherwise, this
      // memoize the `Intl*` constructors and cache them for the lifecycle of
      // this IntlProvider instance.


      var _ref = intlContext || {},
          _ref$formatters = _ref.formatters,
          formatters = _ref$formatters === void 0 ? {
        getDateTimeFormat: memoizeFormatConstructor(Intl.DateTimeFormat),
        getNumberFormat: memoizeFormatConstructor(Intl.NumberFormat),
        getMessageFormat: memoizeFormatConstructor(MessageFormat),
        getRelativeFormat: memoizeFormatConstructor(RelativeFormat),
        getPluralRules: memoizeFormatConstructor(Intl.PluralRules)
      } : _ref$formatters;

      _this.state = {
        context: {
          formatters: formatters,
          // Wrapper to provide stable "now" time for initial render.
          now: function now() {
            return _this._didDisplay ? Date.now() : initialNow;
          }
        }
      };
      return _this;
    }

    _createClass(IntlProvider, [{
      key: "getContext",
      value: function getContext() {
        return this.state.context;
      }
    }, {
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate() {
        for (var _len = arguments.length, next = new Array(_len), _key = 0; _key < _len; _key++) {
          next[_key] = arguments[_key];
        }

        return shouldIntlComponentUpdate.apply(void 0, [this].concat(next));
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        this._didDisplay = true;
      }
    }, {
      key: "render",
      value: function render() {
        return React__default.createElement(Provider, {
          value: this.getContext()
        }, React.Children.only(this.props.children));
      }
    }], [{
      key: "getDerivedStateFromProps",
      value: function getDerivedStateFromProps(nextProps, prevState) {
        var intlContext = nextProps.intl; // Build a whitelisted config object from `props`, defaults, and
        // `props.intl`, if an <IntlProvider> exists in the ancestry.

        var filteredProps = filterProps(nextProps, intlConfigPropNames, intlContext || {});

        if (!shallowEquals(filteredProps, prevState.filteredProps)) {
          var config = getConfig(filteredProps);
          var boundFormatFns = getBoundFormatFns(config, prevState);
          return {
            filteredProps: filteredProps,
            context: _objectSpread({}, prevState.context, config, boundFormatFns)
          };
        }

        return null;
      }
    }]);

    return IntlProvider;
  }(React.Component);

  _defineProperty(IntlProvider$1, "displayName", 'IntlProvider');

  IntlProvider$1.propTypes = _objectSpread({}, intlConfigPropTypes, {
    children: PropTypes.element.isRequired,
    initialNow: PropTypes.any
  });
  var provider = withIntl(IntlProvider$1, {
    enforceContext: false
  }); // to be able to inherit values from parent providers

  var FormattedDate =
  /*#__PURE__*/
  function (_Component) {
    _inherits(FormattedDate, _Component);

    function FormattedDate(props) {
      var _this;

      _classCallCheck(this, FormattedDate);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(FormattedDate).call(this, props));
      invariantIntlContext(props);
      return _this;
    }

    _createClass(FormattedDate, [{
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState) {
        return shouldIntlComponentUpdate(this, nextProps, nextState);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props$intl = this.props.intl,
            formatDate = _this$props$intl.formatDate,
            Text = _this$props$intl.textComponent;
        var _this$props = this.props,
            value = _this$props.value,
            children = _this$props.children;
        var formattedDate = formatDate(value, this.props);

        if (typeof children === 'function') {
          return children(formattedDate);
        }

        return React__default.createElement(Text, null, formattedDate);
      }
    }]);

    return FormattedDate;
  }(React.Component);

  _defineProperty(FormattedDate, "displayName", 'FormattedDate');

  FormattedDate.propTypes = _objectSpread({}, dateTimeFormatPropTypes, {
    intl: intlShape,
    value: PropTypes.any.isRequired,
    format: PropTypes.string,
    children: PropTypes.func
  });
  var date = withIntl(FormattedDate);

  var FormattedTime =
  /*#__PURE__*/
  function (_Component) {
    _inherits(FormattedTime, _Component);

    function FormattedTime(props) {
      var _this;

      _classCallCheck(this, FormattedTime);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(FormattedTime).call(this, props));
      invariantIntlContext(props);
      return _this;
    }

    _createClass(FormattedTime, [{
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState) {
        return shouldIntlComponentUpdate(this, nextProps, nextState);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props$intl = this.props.intl,
            formatTime = _this$props$intl.formatTime,
            Text = _this$props$intl.textComponent;
        var _this$props = this.props,
            value = _this$props.value,
            children = _this$props.children;
        var formattedTime = formatTime(value, this.props);

        if (typeof children === 'function') {
          return children(formattedTime);
        }

        return React__default.createElement(Text, null, formattedTime);
      }
    }]);

    return FormattedTime;
  }(React.Component);

  _defineProperty(FormattedTime, "displayName", 'FormattedTime');

  FormattedTime.propTypes = _objectSpread({}, dateTimeFormatPropTypes, {
    intl: intlShape,
    value: PropTypes.any.isRequired,
    format: PropTypes.string,
    children: PropTypes.func
  });
  var time = withIntl(FormattedTime);

  var SECOND = 1000;
  var MINUTE = 1000 * 60;
  var HOUR = 1000 * 60 * 60;
  var DAY = 1000 * 60 * 60 * 24; // The maximum timer delay value is a 32-bit signed integer.
  // See: https://mdn.io/setTimeout

  var MAX_TIMER_DELAY = 2147483647;

  function selectUnits$1(delta) {
    var absDelta = Math.abs(delta);

    if (absDelta < MINUTE) {
      return 'second';
    }

    if (absDelta < HOUR) {
      return 'minute';
    }

    if (absDelta < DAY) {
      return 'hour';
    } // The maximum scheduled delay will be measured in days since the maximum
    // timer delay is less than the number of milliseconds in 25 days.


    return 'day';
  }

  function getUnitDelay(units) {
    switch (units) {
      case 'second':
        return SECOND;

      case 'minute':
        return MINUTE;

      case 'hour':
        return HOUR;

      case 'day':
        return DAY;

      default:
        return MAX_TIMER_DELAY;
    }
  }

  function isSameDate(a, b) {
    if (a === b) {
      return true;
    }

    var aTime = new Date(a).getTime();
    var bTime = new Date(b).getTime();
    return isFinite(aTime) && isFinite(bTime) && aTime === bTime;
  }

  var FormattedRelative =
  /*#__PURE__*/
  function (_Component) {
    _inherits(FormattedRelative, _Component);

    function FormattedRelative(props) {
      var _this;

      _classCallCheck(this, FormattedRelative);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(FormattedRelative).call(this, props));
      invariantIntlContext(props);
      var now = isFinite(props.initialNow) ? Number(props.initialNow) : props.intl.now(); // `now` is stored as state so that `render()` remains a function of
      // props + state, instead of accessing `Date.now()` inside `render()`.

      _this.state = {
        now: now,
        prevValue: props.value
      };
      return _this;
    }

    _createClass(FormattedRelative, [{
      key: "scheduleNextUpdate",
      value: function scheduleNextUpdate(props, state) {
        var _this2 = this;

        // Cancel and pending update because we're scheduling a new update.
        clearTimeout(this._timer);
        var value = props.value,
            units = props.units,
            updateInterval = props.updateInterval;
        var time = new Date(value).getTime(); // If the `updateInterval` is falsy, including `0` or we don't have a
        // valid date, then auto updates have been turned off, so we bail and
        // skip scheduling an update.

        if (!updateInterval || !isFinite(time)) {
          return;
        }

        var delta = time - state.now;
        var unitDelay = getUnitDelay(units || selectUnits$1(delta));
        var unitRemainder = Math.abs(delta % unitDelay); // We want the largest possible timer delay which will still display
        // accurate information while reducing unnecessary re-renders. The delay
        // should be until the next "interesting" moment, like a tick from
        // "1 minute ago" to "2 minutes ago" when the delta is 120,000ms.

        var delay = delta < 0 ? Math.max(updateInterval, unitDelay - unitRemainder) : Math.max(updateInterval, unitRemainder);
        this._timer = setTimeout(function () {
          _this2.setState({
            now: _this2.props.intl.now()
          });
        }, delay);
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        this.scheduleNextUpdate(this.props, this.state);
      }
    }, {
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate() {
        for (var _len = arguments.length, next = new Array(_len), _key = 0; _key < _len; _key++) {
          next[_key] = arguments[_key];
        }

        return shouldIntlComponentUpdate.apply(void 0, [this].concat(next));
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        this.scheduleNextUpdate(this.props, this.state);
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        clearTimeout(this._timer);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props$intl = this.props.intl,
            formatRelative = _this$props$intl.formatRelative,
            Text = _this$props$intl.textComponent;
        var _this$props = this.props,
            value = _this$props.value,
            children = _this$props.children;
        var formattedRelative = formatRelative(value, _objectSpread({}, this.props, this.state));

        if (typeof children === 'function') {
          return children(formattedRelative);
        }

        return React__default.createElement(Text, null, formattedRelative);
      }
    }], [{
      key: "getDerivedStateFromProps",
      value: function getDerivedStateFromProps(_ref, _ref2) {
        var value = _ref.value,
            intl = _ref.intl;
        var prevValue = _ref2.prevValue;

        // When the `props.value` date changes, `state.now` needs to be updated,
        // and the next update can be rescheduled.
        if (!isSameDate(value, prevValue)) {
          return {
            now: intl.now(),
            prevValue: value
          };
        }

        return null;
      }
    }]);

    return FormattedRelative;
  }(React.Component);

  _defineProperty(FormattedRelative, "displayName", 'FormattedRelative');

  _defineProperty(FormattedRelative, "defaultProps", {
    updateInterval: 1000 * 10
  });

  FormattedRelative.propTypes = _objectSpread({}, relativeFormatPropTypes, {
    intl: intlShape,
    value: PropTypes.any.isRequired,
    format: PropTypes.string,
    updateInterval: PropTypes.number,
    initialNow: PropTypes.any,
    children: PropTypes.func
  });
  var relative = withIntl(FormattedRelative);

  var FormattedNumber =
  /*#__PURE__*/
  function (_Component) {
    _inherits(FormattedNumber, _Component);

    function FormattedNumber(props) {
      var _this;

      _classCallCheck(this, FormattedNumber);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(FormattedNumber).call(this, props));
      invariantIntlContext(props);
      return _this;
    }

    _createClass(FormattedNumber, [{
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState) {
        return shouldIntlComponentUpdate(this, nextProps, nextState);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props$intl = this.props.intl,
            formatNumber = _this$props$intl.formatNumber,
            Text = _this$props$intl.textComponent;
        var _this$props = this.props,
            value = _this$props.value,
            children = _this$props.children;
        var formattedNumber = formatNumber(value, this.props);

        if (typeof children === 'function') {
          return children(formattedNumber);
        }

        return React__default.createElement(Text, null, formattedNumber);
      }
    }]);

    return FormattedNumber;
  }(React.Component);

  _defineProperty(FormattedNumber, "displayName", 'FormattedNumber');

  FormattedNumber.propTypes = _objectSpread({}, numberFormatPropTypes, {
    intl: intlShape,
    value: PropTypes.any.isRequired,
    format: PropTypes.string,
    children: PropTypes.func
  });
  var number$1 = withIntl(FormattedNumber);

  var FormattedPlural =
  /*#__PURE__*/
  function (_Component) {
    _inherits(FormattedPlural, _Component);

    function FormattedPlural(props) {
      var _this;

      _classCallCheck(this, FormattedPlural);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(FormattedPlural).call(this, props));
      invariantIntlContext(props);
      return _this;
    }

    _createClass(FormattedPlural, [{
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState) {
        return shouldIntlComponentUpdate(this, nextProps, nextState);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props$intl = this.props.intl,
            formatPlural = _this$props$intl.formatPlural,
            Text = _this$props$intl.textComponent;
        var _this$props = this.props,
            value = _this$props.value,
            other = _this$props.other,
            children = _this$props.children;
        var pluralCategory = formatPlural(value, this.props);
        var formattedPlural = this.props[pluralCategory] || other;

        if (typeof children === 'function') {
          return children(formattedPlural);
        }

        return React__default.createElement(Text, null, formattedPlural);
      }
    }]);

    return FormattedPlural;
  }(React.Component);

  _defineProperty(FormattedPlural, "displayName", 'FormattedPlural');

  _defineProperty(FormattedPlural, "defaultProps", {
    type: 'cardinal'
  });

  FormattedPlural.propTypes = _objectSpread({}, pluralFormatPropTypes, {
    intl: intlShape,
    value: PropTypes.any.isRequired,
    other: PropTypes.node.isRequired,
    zero: PropTypes.node,
    one: PropTypes.node,
    two: PropTypes.node,
    few: PropTypes.node,
    many: PropTypes.node,
    children: PropTypes.func
  });
  var plural = withIntl(FormattedPlural);

  var defaultFormatMessage = function defaultFormatMessage(descriptor, values) {
    {
      console.error('[React Intl] Could not find required `intl` object. <IntlProvider> needs to exist in the component ancestry. Using default message as fallback.');
    }

    return formatMessage({}, {
      getMessageFormat: memoizeFormatConstructor(MessageFormat)
    }, descriptor, values);
  };

  var FormattedMessage =
  /*#__PURE__*/
  function (_Component) {
    _inherits(FormattedMessage, _Component);

    function FormattedMessage(props) {
      var _this;

      _classCallCheck(this, FormattedMessage);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(FormattedMessage).call(this, props));

      if (!props.defaultMessage) {
        invariantIntlContext(props);
      }

      return _this;
    }

    _createClass(FormattedMessage, [{
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState) {
        var values = this.props.values;
        var nextValues = nextProps.values;

        if (!shallowEquals(nextValues, values)) {
          return true;
        } // Since `values` has already been checked, we know they're not
        // different, so the current `values` are carried over so the shallow
        // equals comparison on the other props isn't affected by the `values`.


        var nextPropsToCheck = _objectSpread({}, nextProps, {
          values: values
        });

        return shouldIntlComponentUpdate(this, nextPropsToCheck, nextState);
      }
    }, {
      key: "render",
      value: function render() {
        var _ref = this.props.intl || {},
            _ref$formatMessage = _ref.formatMessage,
            formatMessage = _ref$formatMessage === void 0 ? defaultFormatMessage : _ref$formatMessage,
            _ref$textComponent = _ref.textComponent,
            Text = _ref$textComponent === void 0 ? 'span' : _ref$textComponent;

        var _this$props = this.props,
            id = _this$props.id,
            description = _this$props.description,
            defaultMessage = _this$props.defaultMessage,
            values = _this$props.values,
            _this$props$tagName = _this$props.tagName,
            Component = _this$props$tagName === void 0 ? Text : _this$props$tagName,
            children = _this$props.children;
        var tokenDelimiter;
        var tokenizedValues;
        var elements;
        var hasValues = values && Object.keys(values).length > 0;

        if (hasValues) {
          // Creates a token with a random UID that should not be guessable or
          // conflict with other parts of the `message` string.
          var uid = Math.floor(Math.random() * 0x10000000000).toString(16);

          var generateToken = function () {
            var counter = 0;
            return function () {
              return "ELEMENT-".concat(uid, "-").concat(counter += 1);
            };
          }(); // Splitting with a delimiter to support IE8. When using a regex
          // with a capture group IE8 does not include the capture group in
          // the resulting array.


          tokenDelimiter = "@__".concat(uid, "__@");
          tokenizedValues = {};
          elements = {}; // Iterates over the `props` to keep track of any React Element
          // values so they can be represented by the `token` as a placeholder
          // when the `message` is formatted. This allows the formatted
          // message to then be broken-up into parts with references to the
          // React Elements inserted back in.

          Object.keys(values).forEach(function (name) {
            var value = values[name];

            if (React.isValidElement(value)) {
              var token = generateToken();
              tokenizedValues[name] = tokenDelimiter + token + tokenDelimiter;
              elements[token] = value;
            } else {
              tokenizedValues[name] = value;
            }
          });
        }

        var descriptor = {
          id: id,
          description: description,
          defaultMessage: defaultMessage
        };
        var formattedMessage = formatMessage(descriptor, tokenizedValues || values);
        var nodes;
        var hasElements = elements && Object.keys(elements).length > 0;

        if (hasElements) {
          // Split the message into parts so the React Element values captured
          // above can be inserted back into the rendered message. This
          // approach allows messages to render with React Elements while
          // keeping React's virtual diffing working properly.
          nodes = formattedMessage.split(tokenDelimiter).filter(function (part) {
            return !!part;
          }).map(function (part) {
            return elements[part] || part;
          });
        } else {
          nodes = [formattedMessage];
        }

        if (typeof children === 'function') {
          return children.apply(void 0, _toConsumableArray(nodes));
        } // Needs to use `createElement()` instead of JSX, otherwise React will
        // warn about a missing `key` prop with rich-text message formatting.


        return React.createElement.apply(void 0, [Component, null].concat(_toConsumableArray(nodes)));
      }
    }]);

    return FormattedMessage;
  }(React.Component);

  _defineProperty(FormattedMessage, "displayName", 'FormattedMessage');

  _defineProperty(FormattedMessage, "defaultProps", {
    values: {}
  });

  FormattedMessage.propTypes = _objectSpread({}, messageDescriptorPropTypes, {
    intl: intlShape,
    values: PropTypes.object,
    tagName: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
    children: PropTypes.func
  });
  var BaseFormattedMessage = FormattedMessage;
  var message = withIntl(FormattedMessage);

  var FormattedHTMLMessage =
  /*#__PURE__*/
  function (_BaseFormattedMessage) {
    _inherits(FormattedHTMLMessage, _BaseFormattedMessage);

    function FormattedHTMLMessage() {
      _classCallCheck(this, FormattedHTMLMessage);

      return _possibleConstructorReturn(this, _getPrototypeOf(FormattedHTMLMessage).apply(this, arguments));
    }

    _createClass(FormattedHTMLMessage, [{
      key: "render",
      value: function render() {
        var _this$props$intl = this.props.intl,
            formatHTMLMessage = _this$props$intl.formatHTMLMessage,
            Text = _this$props$intl.textComponent;
        var _this$props = this.props,
            id = _this$props.id,
            description = _this$props.description,
            defaultMessage = _this$props.defaultMessage,
            rawValues = _this$props.values,
            _this$props$tagName = _this$props.tagName,
            Component = _this$props$tagName === void 0 ? Text : _this$props$tagName,
            children = _this$props.children;
        var descriptor = {
          id: id,
          description: description,
          defaultMessage: defaultMessage
        };
        var formattedHTMLMessage = formatHTMLMessage(descriptor, rawValues);

        if (typeof children === 'function') {
          return children(formattedHTMLMessage);
        } // Since the message presumably has HTML in it, we need to set
        // `innerHTML` in order for it to be rendered and not escaped by React.
        // To be safe, all string prop values were escaped when formatting the
        // message. It is assumed that the message is not UGC, and came from the
        // developer making it more like a template.
        //
        // Note: There's a perf impact of using this component since there's no
        // way for React to do its virtual DOM diffing.


        var html = {
          __html: formattedHTMLMessage
        };
        return React__default.createElement(Component, {
          dangerouslySetInnerHTML: html
        });
      }
    }]);

    return FormattedHTMLMessage;
  }(BaseFormattedMessage);

  _defineProperty(FormattedHTMLMessage, "displayName", 'FormattedHTMLMessage');

  var htmlMessage = withIntl(FormattedHTMLMessage);

  /*
   * Copyright 2015, Yahoo Inc.
   * Copyrights licensed under the New BSD License.
   * See the accompanying LICENSE file for terms.
   */

  exports.FormattedDate = date;
  exports.FormattedHTMLMessage = htmlMessage;
  exports.FormattedMessage = message;
  exports.FormattedNumber = number$1;
  exports.FormattedPlural = plural;
  exports.FormattedRelative = relative;
  exports.FormattedTime = time;
  exports.IntlContext = Context;
  exports.IntlProvider = provider;
  exports.defineMessages = defineMessages;
  exports.injectIntl = withIntl;
  exports.intlShape = intlShape;
  exports.useIntl = useIntl;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=react-intl.js.map
